# StarAlgebras

| **Documentation** | **Build Status** |
|:-----------------:|:----------------:|
| [![][docs-stable-img]][docs-stable-url] | [![Build Status][build-img]][build-url] |
| [![][docs-latest-img]][docs-latest-url] | [![Codecov branch][codecov-img]][codecov-url] |
----

The package implements `*`-algebras with basis. The prime example use are group
or monoid algebras (or their finite dimensional subspaces).
An example usage can be as follows.

```julia
julia> using StarAlgebras; import StarAlgebras as SA

julia> using PermutationGroups

julia> G = PermGroup(perm"(1,2)", perm"(1,2,3)")
Permutation group on 2 generators generated by
 (1,2)
 (1,2,3)

julia> b = SA.DiracBasis(G);

julia> RG = StarAlgebra(G, b)
*-algebra of PermGroup( (1,2), (1,2,3) )

```

This creates the group algebra of the symmetric group. There are a few ways to
construct its elements:
```julia
julia> zero(RG)
0·()

julia> one(RG) # the canonical unit
1·()

julia> RG(1) # the same
1·()

julia> RG(-5.0) # coerce a scalar to the ring
-5.0·()

julia> RG(rand(G)) # the indicator function on a random element of G
1·()

julia> f = sum(rand(-3:3)*RG(rand(G)) for _ in 1:12) # an element given by vectors of coefficients in the basis
-1·() +4·(1,2) +5·(1,2,3) -2·(1,3,2) -2·(1,3)

julia> SA.star(g::PermutationGroups.AbstractPermutation) = inv(g); star(f) # the star involution
-1·() +4·(1,2) +5·(1,3,2) -2·(1,2,3) -2·(1,3)

julia> f' # the same
-1·() +4·(1,2) +5·(1,3,2) -2·(1,2,3) -2·(1,3)

julia> f' == f
false

julia> f - f' # the alternating part
7·(1,2,3) -7·(1,3,2)

julia> include(joinpath(dirname(pathof(StarAlgebras)), "..", "examples", "diracs_augmented.jl"))

julia> SA.aug(p::PermutationGroups.Permutation) = 1

julia> SA.aug(f) # sum of coefficients
4

julia> SA.aug(f - f') # sum of coefficients
0

julia> using LinearAlgebra; norm(f, 2) # 2-norm
25.0

```
By default `f` here is stored as (sparse) coefficients against `basis(RG)`:
```julia
julia> coeffs(f) # same as SA.coeffs(f, basis(RG))
StarAlgebras.SparseCoefficients{...}(Permutation{...}[(), (1,2), (1,2,3), (1,3,2), (1,3)], [-1, 4, 5, -2, -2])
```

Working directly with elements of `G` one can also write

```julia
julia> g = Permutation(perm"(1,2,3)", G)
(1,2,3)

julia> x = one(RG) - 3RG(g); supp(x) # support of the funtion
2-element Vector{Permutation{…}}:
 ()
 (1,2,3)

julia> x(g) # value of x at g
-3

julia> x(inv(g))
0
```

## Example: Projections in group algebra

Using these functions let's define a few projections in `RG` and check their
orthogonality:
```julia
julia> using Test

julia> l = length(basis(RG))
6

julia> P = sum(RG(g) for g in b) // l # projection to the subspace fixed by all elements of G
1//6·() +1//6·(2,3) +1//6·(1,2) +1//6·(1,2,3) +1//6·(1,3,2) +1//6·(1,3)

julia> @test P * P == P
Test Passed

julia> P3 = 2 * sum(RG(g) for g in b if sign(g) > 0) // l # projection to the subspace fixed by Alt(3) = C₃
1//3·() +1//3·(1,2,3) +1//3·(1,3,2)

julia> @test P3 * P3 == P3
Test Passed

julia> h = PermutationGroups.gens(G,1)
(1,2)

julia> P2 = (RG(one(G)) + RG(h)) // 2 # projection to the C₂-fixed subspace
1//2·() +1//2·(1,2)

julia> @test P2 * P2 == P2
Test Passed

julia> @test P2 * P3 == P3 * P2 == P # their intersection is precisely the same as the one for G
Test Passed

julia> P2m = (RG(1) - RG(h)) // 2 # projection onto the subspace orthogonal to C₂-fixed subspace
1//2·() -1//2·(1,2)

julia> @test P2m * P2m == P2m
Test Passed

julia> @test iszero(P2m * P2) # indeed P2 and P2m are orthogonal
Test Passed
```

This package originated as a tool to compute sum of hermitian squares in
`*`-algebras. These consist not of standard `f*f` summands, but rather
`star(f)*f`. You may think of semi-definite matrices: their Cholesky
decomposition determines `P = Q'·Q`, where `Q'` denotes (conjugate) transpose.
Algebra of matrices with transpose is an (the?) example of a `*`-algebra.
To compute such sums of squares one may either sprinkle the code with `star`s,
or `'` (aka `Base.adjoint` postfix symbol):
```julia
julia> x = RG(Permutation(perm"(1,2,3)", G))
1·(1,2,3)

julia> X = one(RG) - x
1·() -1·(1,2,3)

julia> X'
1·() -1·(1,3,2)

julia> X'*X
2·() -1·(1,2,3) -1·(1,3,2)

julia> @test X'*X == star(X)*X == 2one(X) - x - star(x)
Test Passed

```

## Fixed basis and translation between bases

`b = SA.DiracBasis(G)` takes an iterator (in this case a finite
permutation group `G`) and creates a basis with Dirac multiplicative structure.
This means a basis of a linear space with the multiplicative structure where
multiplication of two basis elements results in a third one. This computation
does not depend on the finiteness of `G`, i.e. is fully lazy.

When the basis is known a priori one can create an efficient `SA.FixedBasis`
which caches (memoizes) the results of multiplications. For example:

```julia
julia> fb = let l = length(basis(RG))
    StarAlgebras.FixedBasis(b; n=l)
end;

julia> fRG = StarAlgebra(G, fb)
*-algebra of PermGroup( (1,2), (1,2,3) )

```

Since the length of the basis is known this time, algebra elements can be stored simply as (sparse) vectors:

```julia
julia> coeffs(one(fRG))
6-element SparseArrays.SparseVector{Int64, Int64} with 1 stored entry:
  [1]  =  1

julia> AlgebraElement(ones(Int, length(basis(fRG)))//6, fRG)
1//6·() +1//6·(2,3) +1//6·(1,2) +1//6·(1,2,3) +1//6·(1,3,2) +1//6·(1,3)

```

To translate coefficients between bases one may call

```julia
julia> coeffs(P2, fb)
6-element SparseArrays.SparseVector{Rational{Int64}, Int64} with 2 stored entries:
  [1]  =  1//2
  [3]  =  1//2

julia> coeffs(coeffs(P2), b, fb) # same as above, from source basis to target basis
6-element SparseArrays.SparseVector{Rational{Int64}, Int64} with 2 stored entries:
  [1]  =  1//2
  [3]  =  1//2

```

Translation in the opposite direction is also possible

```julia
julia> fP2 = AlgebraElement(StarAlgebras.coeffs(P2,fb), fRG)
1//2·() +1//2·(1,2)

julia> StarAlgebras.coeffs(fP2, b)
StarAlgebras.SparseCoefficients{…}(Permutation{…}[(), (1,2)], Rational{Int64}[1//2, 1//2])

julia> P2_ = AlgebraElement(StarAlgebras.coeffs(fP2, b), RG)
1//2·() +1//2·(1,2)

julia> @test P2 == P2_
Test Passed

```

-----
If you happen to use this package please cite either [1712.07167](https://arxiv.org/abs/1712.07167) or [1812.03456](https://arxiv.org/abs/1812.03456). This package superseeds [GroupRings.jl](https://github.com/kalmarek/GroupRings.jl) which was developed and used there. It served its purpose well. Let it rest peacefully.

[docs-stable-img]: https://img.shields.io/badge/docs-stable-blue.svg
[docs-latest-img]: https://img.shields.io/badge/docs-dev-blue.svg
[docs-stable-url]: https://JuliaAlgebra.github.io/StarAlgebras.jl/stable
[docs-latest-url]: https://juliaalgebra.github.io/StarAlgebras.jl/dev

[build-img]: https://github.com/JuliaAlgebra/StarAlgebras.jl/actions/workflows/CI.yml/badge.svg?branch=main
[build-url]: https://github.com/JuliaAlgebra/StarAlgebras.jl/actions?query=workflow%3ACI
[codecov-img]: http://codecov.io/gh/JuliaAlgebra/StarAlgebras.jl/branch/main/graph/badge.svg
[codecov-url]: http://codecov.io/gh/JuliaAlgebra/StarAlgebras.jl

This folder contains example implementations of the different abstract types defined in `StarAlgebras`.
These examples are used in the tests but are stored here outside the `test` folder to increase their visibility.

# This file is a part of StarAlgebras.jl. License is MIT: https://github.com/JuliaAlgebra/StarAlgebras.jl/blob/main/LICENSE
# Copyright (c) 2021-2025: Marek Kaluba, Benoît Legat

# An iterator over all natural numbers
struct NaturalNumbers end
Base.IteratorSize(::Type{NaturalNumbers}) = Base.IsInfinite()
Base.eltype(::NaturalNumbers) = Int
Base.iterate(::NaturalNumbers) = (1, 1)
Base.iterate(::NaturalNumbers, state) = (state + 1, state + 1)
Base.in(i::Int, ::NaturalNumbers) = i >= 1
Base.one(::NaturalNumbers) = 1

function Base.require_one_based_indexing(::SA.MappedBasis{T,Int,NaturalNumbers}) where {T} end

using StarAlgebras
using Documenter

DocMeta.setdocmeta!(StarAlgebras, :DocTestSetup, :(using StarAlgebras); recursive=true)

makedocs(;
    modules=[StarAlgebras],
    authors="Marek Kaluba and Benoît Legat",
    sitename="StarAlgebras.jl",
    format=Documenter.HTML(;
        prettyurls=get(ENV, "CI", "false") == "true",
        assets=String[],
    ),
    pages=[
        "Home" => "index.md",
    ],
)

deploydocs(;
    repo="github.com/JuliaAlgebra/StarAlgebras.jl.git", push_preview=true, devbranch="main"
)

# This file is a part of StarAlgebras.jl. License is MIT: https://github.com/JuliaAlgebra/StarAlgebras.jl/blob/main/LICENSE
# Copyright (c) 2021-2025: Marek Kaluba, Benoît Legat

# example implementation of abstract coefficients
struct ACoeffs{T} <: SA.AbstractCoefficients{UInt32,T}
    vals::Vector{T}
end

# convienience:
ACoeffs(v::AbstractVector) = ACoeffs{valtype(v)}(v)

# AbstractCoefficients API

## Basic API
Base.keys(ac::ACoeffs) = (k for (k, v) in pairs(ac.vals) if !iszero(v))
Base.values(ac::ACoeffs) = (v for v in ac.vals if !iszero(v))
MA.operate!(::typeof(SA.canonical), ac::ACoeffs) = ac
function SA.star(b::SA.AbstractBasis, ac::ACoeffs)
    return ACoeffs([ac.vals[star(b, k)] for k in keys(ac)])
end

# for preallocation in arithmetic
function Base.similar(ac::ACoeffs, ::Type{T}) where {T}
    vals = similar(ac.vals, T)
    MA.operate!(zero, vals)
    return ACoeffs(vals)
end

# the default arithmetic implementation uses this access
Base.getindex(ac::ACoeffs, idx) = ac.vals[idx]
Base.setindex!(ac::ACoeffs, val, idx) = ac.vals[idx] = val
function SA.unsafe_push!(ac::ACoeffs, idx, val)
    ac.vals[idx] = MA.add!!(ac.vals[idx], val)
    return ac
end

# This file is a part of StarAlgebras.jl. License is MIT: https://github.com/JuliaAlgebra/StarAlgebras.jl/blob/main/LICENSE
# Copyright (c) 2021-2025: Marek Kaluba, Benoît Legat

import MutableArithmetics as MA

aug(cfs::Any) = sum(values(cfs))
aug(a::SA.AlgebraElement) = aug(SA.coeffs(a), SA.basis(a))

function aug(cfs, b::SA.AbstractBasis)
    SA.iszero(cfs) && return zero(SA.value_type(cfs))
    return sum(c * aug(b[x]) for (x, c) in SA.nonzero_pairs(cfs))
end

struct Augmented{K} <: SA.AbstractCoefficients{K,Int}
    elt::K
end # corresponds to (elt - 1)

function Base.getindex(aδ::Augmented{K}, i::K) where {K}
    w = aug(aδ.elt)
    isone(aδ.elt) && return zero(w)
    i == aδ.elt && return w
    isone(i) && return -w
    return zero(w)
end

MA.operate!(::typeof(SA.canonical), aδ::Augmented) = aδ

Base.keys(aδ::Augmented) = (k = keys(aδ.elt); (one(first(k)), first(k)))
function Base.values(aδ::Augmented)
    (e, x) = keys(aδ)
    return (aδ[e], aδ[x])
end

function SA.star(basis::SA.AbstractBasis, ad::Augmented)
    return Augmented(SA.star(basis, ad.elt))
end

function Base.show(io::IO, aδ::Augmented)
    ioc = IOContext(io, :limit => true)
    if iszero(aδ)
        print(ioc, "(0)")
    else
        e, x = keys(aδ)
        _, v = values(aδ)
        print(ioc, '(', -v, '·', e, '+', v, '·', x, ')')
    end
end

Base.isless(ad1::Augmented, ad2::Augmented) = isless(ad1.elt, ad2.elt)

aug(::Augmented) = 0

struct AugmentedBasis{T,I,A<:Augmented{T},B<:SA.AbstractBasis{T,I}} <:
       SA.ImplicitBasis{A,A}
    basis::B
end

function AugmentedBasis(basis::SA.DiracBasis{T}) where {T}
    @assert one(SA.object(basis)) in basis
    return AugmentedBasis{T,T,Augmented{T},typeof(basis)}(basis)
end

SA.object(ab::AugmentedBasis) = SA.object(ab.basis)

function Base.IteratorSize(::Type{<:AugmentedBasis{T,I,A,B}}) where {T,I,A,B}
    return Base.IteratorSize(B)
end
Base.haslength(ab::AugmentedBasis) = Base.haslength(ab.basis)

function Base.length(ab::AugmentedBasis)
    @assert Base.haslength(ab.basis)
    return length(ab.basis) - 1
end

function Base.iterate(ab::AugmentedBasis)
    (v, st) = iterate(SA.object(ab))
    isone(v) && return iterate(ab, st)
    return Augmented(v), st
end

function Base.iterate(ab::AugmentedBasis, st)
    (v, st) = let k = iterate(SA.object(ab), st)
        isnothing(k) && return nothing
        k
    end
    isone(v) && return iterate(ab, st)
    return Augmented(v), st
end

Base.in(g, ab::AugmentedBasis) = false
Base.in(ad::Augmented, ab::AugmentedBasis) = ad.elt in ab.basis

function Base.getindex(ab::AugmentedBasis{T,I,A}, x::A) where {T,I,A}
    @assert x.elt in SA.object(ab)
    return x
end

function Base.:(==)(a::AugmentedBasis, b::AugmentedBasis)
    return a.basis == b.basis
end

struct AugmentedMStructure{A,B<:AugmentedBasis,M<:SA.DiracMStructure} <:
       SA.MultiplicativeStructure{A,A}
    basis::B
    op::M
end

function AugmentedMStructure(ab::AugmentedBasis{T,I,A}) where {T,I,A}
    op = SA.DiracMStructure(ab.basis, *)
    return AugmentedMStructure{A,typeof(ab),typeof(op)}(ab, op)
end

SA.mstructure(ab::AugmentedBasis) = AugmentedMStructure(ab)

function MA.promote_operation(
    ::typeof(SA.basis),
    ::Type{<:AugmentedMStructure{A,B}},
) where {A,B}
    return B
end

function Base.:(==)(a::AugmentedMStructure, b::AugmentedMStructure)
    return a.basis == b.basis && a.op == b.op
end

function SA.StarAlgebra(object, ab::AugmentedBasis)
    return SA.StarAlgebra(object, SA.mstructure(ab))
end

function SA.promote_bases_with_maps(
    a::AugmentedMStructure,
    b::AugmentedMStructure,
)
    _a, _b = SA.promote_bases_with_maps(SA.basis(a), SA.basis(b))
    return SA.maybe_promote(a, _a...), SA.maybe_promote(b, _b...)
end

function (mstr::AugmentedMStructure)(aδx::A, aδy::A, ::Type{A}) where {A<:Augmented}
    δxy = first(keys(mstr.op(aδx.elt, aδy.elt)))
    if isone(δxy)
        return SA.SparseCoefficients((aδx, aδy), (-1, -1))
    else
        aδxy = Augmented(δxy)
        #(x-1)*(y-1) = 1 - x - y + xy = -1·(x-1) - 1·(y-1) + 1·(xy-1)
        return SA.SparseCoefficients((aδx, aδy, aδxy), (-1, -1, 1))
    end
end

function SA.coeffs!(
    res::SA.AbstractCoefficients,
    cfs::SA.AbstractCoefficients,
    source::SA.DiracBasis,
    target::AugmentedBasis,
)
    s = aug(cfs)
    if !iszero(s)
        throw(
            "Conversion to $target not possible due to non-zero augmentation: $s",
        )
    end
    for (k, v) in SA.nonzero_pairs(cfs)
        isone(k) && continue
        x = source[k]
        SA.unsafe_push!(res, target[Augmented(x)], v)
    end
    MA.operate!(SA.canonical, res)
    return res
end

# This file is a part of StarAlgebras.jl. License is MIT: https://github.com/JuliaAlgebra/StarAlgebras.jl/blob/main/LICENSE
# Copyright (c) 2021-2025: Marek Kaluba, Benoît Legat

# Adapted from TypedPolynomials via MultivariatePolynomials

"""
    merge_sorted!(result, v1::AbstractVector, v2::AbstractVector; lt, combine, filter, rev=false)

In-place version of [`merge_sorted`](@ref) that writes the result into `result`.
`result` must be large enough to hold the merged output (at most `length(v1) + length(v2)`).
It is resized to the actual output length before returning.
If `rev=true`, the comparison `lt` is reversed.
"""
function merge_sorted!(
    result,
    v1::AbstractVector,
    v2::AbstractVector;
    lt,
    combine,
    filter,
    rev = false,
)
    i = firstindex(result)
    i1 = firstindex(v1)
    i2 = firstindex(v2)
    while i1 <= lastindex(v1) && i2 <= lastindex(v2)
        x1 = v1[i1]
        x2 = v2[i2]
        if x1 == x2
            c = combine(x1, x2)
            if filter(c)
                result[i] = c
                i += 1
            end
            i1 += 1
            i2 += 1
        elseif xor(lt(x1, x2), rev)
            if filter(x1)
                result[i] = x1
                i += 1
            end
            i1 += 1
        else
            if filter(x2)
                result[i] = x2
                i += 1
            end
            i2 += 1
        end
    end
    for j in i1:lastindex(v1)
        if filter(v1[j])
            result[i] = v1[j]
            i += 1
        end
    end
    for j in i2:lastindex(v2)
        if filter(v2[j])
            result[i] = v2[j]
            i += 1
        end
    end
    resize!(result, i - 1)
    return result
end

"""
    first_of(a, b)

Return the first argument. Useful as a `combine` function for [`merge_sorted`](@ref)
to deduplicate without combining values.
"""
first_of(a, _) = a
MA.promote_operation(::typeof(first_of), ::Type{T}, ::Type) where {T} = T

"""
    merge_sorted(v1::AbstractVector, v2::AbstractVector; lt, combine, filter, rev=false)

Merge two sorted vectors `v1` and `v2` into a single sorted vector.
Elements are compared using `lt` (a less-than function).
When two elements are equal (neither is less than the other),
they are combined using `combine(x1, x2)`.
Elements for which `filter` returns `false` are dropped.
If `rev=true`, the comparison `lt` is reversed.
"""
function merge_sorted(
    v1::AbstractVector,
    v2::AbstractVector;
    lt,
    combine,
    filter,
    rev = false,
)
    T = MA.promote_operation(combine, eltype(v1), eltype(v2))
    result = Vector{T}(undef, length(v1) + length(v2))
    return merge_sorted!(result, v1, v2; lt, combine, filter, rev)
end

"""
    merge_sorted(a::Tuple, b::Tuple; lt, combine, filter, rev=false)

Merge two sorted tuples, removing duplicates. Returns a tuple.
If `rev=true`, the comparison `lt` is reversed.
"""
merge_sorted(::Tuple{}, ::Tuple{}; lt, combine, filter, rev = false) = ()
merge_sorted(a::Tuple, ::Tuple{}; lt, combine, filter, rev = false) = a
merge_sorted(::Tuple{}, b::Tuple; lt, combine, filter, rev = false) = b
function merge_sorted(a::Tuple, b::Tuple; lt, combine, filter, rev = false)
    x = first(a)
    y = first(b)
    if x == y
        z = combine(x, y)
        tail =
            merge_sorted(Base.tail(a), Base.tail(b); lt, combine, filter, rev)
        if filter(z)
            return (z, tail...)
        else
            return tail
        end
    elseif xor(lt(x, y), rev)
        return (x, merge_sorted(Base.tail(a), b; lt, combine, filter, rev)...)
    else
        return (y, merge_sorted(a, Base.tail(b); lt, combine, filter, rev)...)
    end
end

"""
    multi_findsorted(x, y; lt = isless)

Given two sorted collections `x` and `y`, return a vector `I` of length `length(x)`
where `I[i]` is the index of `x[i]` in `y`, or `0` if `x[i]` does not occur in `y`.
Both `x` and `y` must be sorted according to `lt`.
"""
function multi_findsorted(x, y; lt = isless)
    I = zeros(Int, length(x))
    j = 1
    for i in eachindex(x)
        while j ≤ length(y) && lt(y[j], x[i])
            j += 1
        end
        if j ≤ length(y) && x[i] == y[j]
            I[i] = j
        end
    end
    return I
end

"""
    merge_bases_with_maps(basis1::SubBasis, basis2::SubBasis)

Merge two sorted `SubBasis` with the same parent basis into a single `SubBasis`.
Returns `(merged_basis, I1, I2)` where `I1` and `I2` are index vectors
such that `I1[i]` is the index of the `i`th element of `merged_basis` in `basis1`
(or `0` if absent), and similarly for `I2`.
"""
function merge_bases_with_maps(basis1::SB, basis2::SB) where {SB<:SubBasis}
    @assert basis1.parent_basis == basis2.parent_basis
    @assert basis1.is_sorted
    @assert basis2.is_sorted
    lt = comparable(parent(basis1))
    keys = merge_sorted(
        basis1.keys,
        basis2.keys;
        lt,
        combine = first_of,
        filter = _ -> true,
    )
    I1 = multi_findsorted(keys, basis1.keys; lt)
    I2 = multi_findsorted(keys, basis2.keys; lt)
    return SubBasis(basis1.parent_basis, keys), I1, I2
end

"""
    merge_bases(basis1::SubBasis, basis2::SubBasis)

Merge two sorted `SubBasis` with the same parent basis into a single `SubBasis`.
See also [`merge_bases_with_maps`](@ref).
"""
function merge_bases(basis1::SB, basis2::SB) where {SB<:SubBasis}
    return first(merge_bases_with_maps(basis1, basis2))
end

# This file is a part of StarAlgebras.jl. License is MIT: https://github.com/JuliaAlgebra/StarAlgebras.jl/blob/main/LICENSE
# Copyright (c) 2021-2025: Marek Kaluba, Benoît Legat

@testset "QuadraticForm" begin
    A = let alph = [:a, :b, :c]
        fw = FreeWords(alph)
        SA.StarAlgebra(fw, SA.DiracBasis(fw))
    end

    gbasis = let (id, a, b, c) = A.(Iterators.take(SA.object(A), 4))
        # basis has to be star-invariant:
        bas = 1.0 * [one(A), (a + b) / 2, (a + c) / 2, (b + c) / 2]
        SA.FixedBasis(bas)
    end

    m = [
        π 0 0 0
        0 0 0 0
        0 0 0 0
        0 0 0 0
    ]
    Q = SA.QuadraticForm(Gram(m, gbasis))
    b = basis(Q)
    @test A(Q) == π * b[1] * b[1]

    m = [
        0 1//2 0 0
        0 0 0 0
        0 0 0 0
        0 0 0 0
    ]
    Q = SA.QuadraticForm(Gram(m, gbasis))
    b = basis(Q)
    @test A(Q) == 1 // 2 * b[1] * b[2]

    m = [
        0 0 0 0
        0 π -1 0
        0 0 0 0
        0 0 0 0
    ]
    Q = SA.QuadraticForm(Gram(m, gbasis))
    b = basis(Q)
    @test A(Q) == π * b[2] * b[2] - b[2] * b[3]

    m = [
        0 0 0 0
        0 0 0 0
        0 π 0 0
        0 0 1 0
    ]
    Q = SA.QuadraticForm(Gram(m, gbasis))
    b = basis(Q)
    @test A(Q) == π * b[3] * b[2] + b[4] * b[3]

    Q = SA.QuadraticForm{SA.star}(Gram(m, gbasis))
    @test A(Q) == π * b[3]' * b[2] + b[4]' * b[3]

    m = ones(Int, 4, 4)
    Q = SA.QuadraticForm(Gram(m, gbasis))
    @test A(Q) == sum(bi * bj for bi in gbasis for bj in gbasis)

    Q = SA.QuadraticForm{SA.star}(Gram(m, gbasis))
    @test A(Q) == sum(bi' * bj for bi in gbasis for bj in gbasis)

    m = [
        0 0 0 0
        0 0 0 0
        0 π 0 0
        0 0 1 0
    ]
    Q = SA.QuadraticForm(Gram(m, gbasis))
    b = basis(Q)
    @test A(Q) == π * b[3] * b[2] + b[4] * b[3]
end

@testset "Int -> Float basis" begin
    limited = SA.MappedBasis(1:2, float, Int)
    @test !(3.0 in limited)
    @test !haskey(limited, 3)
    @test collect(limited) == [1.0, 2.0]
    implicit = SA.MappedBasis(NaturalNumbers(), float, Int)
    @test 3.0 in implicit
    @test haskey(implicit, 3)
    explicit = SA.sub_basis(implicit, 1:3)
    @test 3.0 in explicit
    @test collect(explicit) == [1.0, 2.0, 3.0]
    @test haskey(explicit, 3)
    m = Bool[
        true false true
        false true false
        true false true
    ]
    Q = SA.QuadraticForm(Gram(m, explicit))
    A = SA.StarAlgebra(PlaceholderObject(), implicit)
    @test A(Q) == SA.AlgebraElement(
        SA.SparseCoefficients([1.0, 3.0, 4.0, 9.0], [1, 2, 1, 1]),
        A,
    )
    mt = SA.MTable(implicit, (0, 0))
    @test mt(2.0, 3.0) == SA.SparseCoefficients([6.0], [1])
    @test mt(2.0, 3.0) == mt(2, 3)
end

@testset "Chebyshev basis" begin
    implicit = cheby_basis()
    mstr = ChebyMStruct(implicit)
    mt = SA.MTable(mstr, (0, 0))
    sub = SA.sub_basis(implicit, 1:3)
    test_vector_interface(sub)
    fixed = SA.FixedBasis(implicit; n = 3)
    test_vector_interface(fixed)
    a = ChebyPoly(2)
    b = ChebyPoly(3)
    expected =
        SA.SparseCoefficients((ChebyPoly(1), ChebyPoly(5)), (1 // 2, 1 // 2))
    for mult in [mstr, mt]
        @test mult(a, b) == expected
        @test mult(a, b, Int) == mult(2, 3)
        @test mult(a, b) == mult(2, 3, ChebyPoly)
        m = [
            2 1 // 2 0
            1 // 2 0 2
            0 2 1
        ]
        A = SA.StarAlgebra(PlaceholderObject(), mult)
        for explicit in [sub, fixed]
            Q = SA.QuadraticForm(Gram(m, explicit))
            @test A(Q) == SA.AlgebraElement(
                SA.SparseCoefficients(
                    [0, 1, 2, 3, 5, 6],
                    [3//2, 5//2, 1, 1//2, 2, 1//2],
                ),
                A,
            )
        end
    end
end

# This file is a part of StarAlgebras.jl. License is MIT: https://github.com/JuliaAlgebra/StarAlgebras.jl/blob/main/LICENSE
# Copyright (c) 2021-2025: Marek Kaluba, Benoît Legat

# Example implementation of Bivariate polynomials
# See MultivariatePolynomials.jl for general implementation
struct ExponentsIterator end
Base.eltype(::Type{ExponentsIterator}) = NTuple{2,Int}
Base.IteratorSize(::Type{ExponentsIterator}) = Base.IsInfinite()

function Base.iterate(::ExponentsIterator)
    z = (0, 0)
    return z, (z, 0)
end

function Base.iterate(::ExponentsIterator, state)
    z, deg = state
    if iszero(z[2])
        deg += 1
        z = (0, deg)
    else
        z = (z[1] + 1, z[2] - 1)
    end
    return z, (z, deg)
end

function grlex(a::NTuple{2,Int}, b::NTuple{2,Int})
    return isless((sum(a), a), (sum(b), b))
end

struct Monomial
    exponents::NTuple{2,Int}
end

Base.one(::Monomial) = Monomial((0, 0))
Base.:*(a::Monomial, b::Monomial) = Monomial(a.exponents .+ b.exponents)

monomial(exp) = Monomial(exp)
exponents(mono::Monomial) = mono.exponents

SA.comparable(::ExponentsIterator) = grlex

function bivariate_algebra()
    exps = ExponentsIterator()
    basis = SA.MappedBasis(exps, monomial, exponents)
    mstr = SA.DiracMStructure(basis, *)
    object = Monomial((0, 0))
    return SA.StarAlgebra(object, mstr)
end

# This file is a part of StarAlgebras.jl. License is MIT: https://github.com/JuliaAlgebra/StarAlgebras.jl/blob/main/LICENSE
# Copyright (c) 2021-2025: Marek Kaluba, Benoît Legat

struct SparseCoefficients{K,V,Vk,Vv,L} <: AbstractCoefficients{K,V}
    basis_elements::Vk
    values::Vv
    isless::L
end

function SparseCoefficients(elts::Ks, vals::Vs, isless = isless) where {Ks,Vs}
    return SparseCoefficients{eltype(elts),eltype(vals),Ks,Vs,typeof(isless)}(
        elts,
        vals,
        isless,
    )
end

Base.keys(sc::SparseCoefficients) = sc.basis_elements
Base.values(sc::SparseCoefficients) = sc.values
function Base.copy(sc::SparseCoefficients)
    return SparseCoefficients(copy(keys(sc)), copy(values(sc)), sc.isless)
end

function _search(keys::Tuple, key; lt)
    # `searchsortedfirst` is not defined for `Tuple`
    return findfirst(isequal(key), keys)
end

function _search(keys, key::K; lt) where {K}
    return searchsortedfirst(keys, key; lt)
end

function Base.getindex(sc::SparseCoefficients{K}, key::K) where {K}
    k = _search(sc.basis_elements, key; lt = sc.isless)
    if k in eachindex(sc.basis_elements)
        v = sc.values[k]
        if sc.basis_elements[k] == key
            return v
        else
            return zero(v)
        end
    else
        return zero(value_type(sc))
    end
end

function Base.setindex!(sc::SparseCoefficients{K}, val, key::K) where {K}
    k = searchsortedfirst(sc.basis_elements, key; lt = sc.isless)
    if k in eachindex(sc.basis_elements) && sc.basis_elements[k] == key
        sc.values[k] = val
    else
        insert!(sc.basis_elements, k, key)
        insert!(sc.values, k, val)
    end
    return sc
end

################
# Broadcasting #
################

struct BroadcastStyle{K} <: Broadcast.BroadcastStyle end

Base.broadcastable(sc::SparseCoefficients) = sc
function Base.BroadcastStyle(::Type{<:SparseCoefficients{K}}) where {K}
    return BroadcastStyle{K}()
end
# Disallow mixing broadcasts.
function Base.BroadcastStyle(::BroadcastStyle, ::Base.BroadcastStyle)
    return throw(
        ArgumentError(
            "Cannot broadcast `StarAlgebras.SparseCoefficients` with" *
            " another array of different type",
        ),
    )
end

# Allow broadcasting over scalars.
function Base.BroadcastStyle(
    style::BroadcastStyle,
    ::Base.Broadcast.DefaultArrayStyle{0},
)
    return style
end

# Used for broadcasting
Base.axes(sc::SparseCoefficients) = (sc.basis_elements,)
#Base.Broadcast.BroadcastStyle(::Type{<:SparseCoefficients{K}}) where {K} = SparseArrays.HigherOrderFns.SparseVecStyle()
#SparseArrays.HigherOrderFns.nonscalararg(::SparseCoefficients) = true

# `_get_arg` and `getindex` are inspired from `JuMP.Containers.SparseAxisArray`
_getindex(x::SparseCoefficients, index) = getindex(x, index)
_getindex(x::Any, ::Any) = x
_getindex(x::Ref, ::Any) = x[]

function _get_arg(args::Tuple, index)
    return (_getindex(first(args), index), _get_arg(Base.tail(args), index)...)
end
_get_arg(::Tuple{}, _) = ()

function Base.getindex(bc::Broadcast.Broadcasted{<:BroadcastStyle}, index)
    return bc.f(_get_arg(bc.args, index)...)
end

function Base.similar(
    bc::Broadcast.Broadcasted{<:BroadcastStyle},
    ::Type{T},
) where {T}
    return similar(_first_sparse_coeffs(bc.args...), T)
end

_first_sparse_coeffs(c::SparseCoefficients, args...) = c
_first_sparse_coeffs(_, args...) = _first_sparse_coeffs(args...)

function Base.zero(sc::SparseCoefficients)
    return SparseCoefficients(empty(keys(sc)), empty(values(sc)), sc.isless)
end

_similar(x::Tuple) = _similar(x, typeof(x[1]))
_similar(x::Tuple, ::Type{T}) where {T} = Vector{T}(undef, length(x))
_similar(x) = similar(x)
_similar(x, ::Type{T}) where {T} = similar(x, T)

_similar_type(::Type{<:Tuple}, ::Type{T}) where {T} = Vector{T}
_similar_type(::Type{V}, ::Type{T}) where {V,T} = similar_type(V, T)

function similar_type(
    ::Type{SparseCoefficients{K,V,Vk,Vv,L}},
    ::Type{T},
) where {K,V,Vk,Vv,T,L}
    return SparseCoefficients{K,T,_similar_type(Vk, K),_similar_type(Vv, T),L}
end

function Base.similar(
    s::SparseCoefficients,
    ::Type{T} = value_type(s),
) where {T}
    return SparseCoefficients(
        collect(s.basis_elements),
        _similar(s.values, T),
        s.isless,
    )
end

function Base.convert(
    ::Type{SparseCoefficients{K,V,Vh,Vv,L}},
    s::SparseCoefficients{K,V,Vh,Vv,L},
) where {K,V,Vh,Vv,L}
    return s
end

_collect_if_needed(::Type, v) = v
_collect_if_needed(::Type{<:AbstractVector}, t::Tuple) = collect(t)

function Base.convert(
    ::Type{SparseCoefficients{K,V,Vh,Vv,L}},
    s::SparseCoefficients,
) where {K,V,Vh,Vv,L}
    return SparseCoefficients{K,V,Vh,Vv,L}(
        _collect_if_needed(Vh, s.basis_elements),
        _collect_if_needed(Vv, s.values),
        s.isless,
    )
end

function map_keys(f::Function, s::SparseCoefficients)
    return SparseCoefficients(map(f, s.basis_elements), s.values, s.isless)
end

function MA.mutability(
    ::Type{<:SparseCoefficients{K,V,Vk,Vv}},
    ::typeof(canonical),
    arg::Vararg{Type},
) where {K,V,Vk,Vv}
    # return MA.IsMutable()
    return MA.mutability(Vk)
end

### temporary convenience? how to handle this?
function __prealloc(X::SparseCoefficients, a::Number, op)
    T = MA.promote_operation(op, value_type(X), typeof(a))
    return similar(X, T)
end

function __prealloc(X::SparseCoefficients, Y::SparseCoefficients, op)
    # this is not even correct for op = *
    T = MA.promote_operation(op, value_type(X), value_type(Y))
    return similar(X, T)
end

function unsafe_push!(res::SparseCoefficients, key, value)
    push!(res.basis_elements, key)
    push!(res.values, value)
    return res
end

# `{...,L}` is needed to force Julia specialize on the function type
# Otherwise, we get one allocation when we call `issorted`
# See https://docs.julialang.org/en/v1/manual/performance-tips/#Be-aware-of-when-Julia-avoids-specializing
function MA.operate!(
    ::typeof(canonical),
    res::SparseCoefficients{K,V,Vk,Vv,L},
) where {K,V,Vk,Vv,L}
    sorted = issorted(res.basis_elements; lt = res.isless)
    distinct = allunique(res.basis_elements)
    if sorted && distinct && !any(iszero, res.values)
        return res
    end

    if !sorted
        p = sortperm(res.basis_elements; lt = res.isless)
        permute!(res.basis_elements, p)
        permute!(res.values, p)
    end

    todelete = BitSet()
    for i in firstindex(res.basis_elements):(lastindex(res.basis_elements)-1)
        if iszero(res.values[i])
            push!(todelete, i)
        elseif res.basis_elements[i] == res.basis_elements[i+1]
            res.values[i+1] += res.values[i]
            push!(todelete, i)
        end
    end
    if iszero(last(values(res)))
        push!(todelete, lastindex(res.basis_elements))
    end
    deleteat!(res.basis_elements, todelete)
    deleteat!(res.values, todelete)
    return res
end

# arithmetic on coefficients; performance overloads

function MA.operate!(::typeof(zero), s::SparseCoefficients)
    empty!(s.basis_elements)
    empty!(s.values)
    return s
end

function MA.operate_to!(
    res::SparseCoefficients,
    ::typeof(-),
    X::SparseCoefficients,
)
    return MA.operate_to!(res, *, X, -1)
end

function MA.operate_to!(
    res::SparseCoefficients,
    ::typeof(*),
    X::SparseCoefficients,
    a::Number,
)
    if res === X
        res.values .*= a
    else
        resize!(res.basis_elements, length(X.basis_elements))
        resize!(res.values, length(res.basis_elements))
        res.basis_elements .= X.basis_elements
        res.values .= a .* X.values
    end

    return res
end

function MA.operate_to!(
    res::SparseCoefficients,
    ::typeof(+),
    X::SparseCoefficients,
    Y::SparseCoefficients,
)
    if res === X
        append!(res.basis_elements, Y.basis_elements)
        append!(res.values, Y.values)
    elseif res === Y
        append!(res.basis_elements, X.basis_elements)
        append!(res.values, X.values)
    else
        MA.operate!(zero, res)
        append!(res.basis_elements, X.basis_elements, Y.basis_elements)
        append!(res.values, X.values, Y.values)
    end
    MA.operate!(canonical, res)
    return res
end

# This file is a part of StarAlgebras.jl. License is MIT: https://github.com/JuliaAlgebra/StarAlgebras.jl/blob/main/LICENSE
# Copyright (c) 2021-2025: Marek Kaluba, Benoît Legat

@testset "Permutation group algebra: arithmetic " begin
    G = PermGroup(perm"(1,2,3)", perm"(1,2)")
    b = SA.DiracBasis(G)
    RG = StarAlgebra(G, b)

    @test contains(sprint(show, RG), "*-algebra of")

    @testset "Module structure" begin
        sc = SA.SparseCoefficients(
            collect(SA.object(RG)),
            ones(Int, length(basis(RG))),
        )
        a = AlgebraElement(sc, RG)

        @test -a isa AlgebraElement
        @test coeffs(-a) == -coeffs(a)
        @test zero(coeffs(a)) == coeffs(zero(a))

        @test 2 * a isa AlgebraElement
        @test eltype(2 * a) == typeof(2)
        @test coeffs(2 * a) == 2coeffs(a)

        @test eltype(2a) == Int
        y = div(2a, 2)
        @test y == a
        @test eltype(y) == Int

        @test 2.0 * a isa AlgebraElement
        @test eltype(2.0 * a) == typeof(2.0)
        @test coeffs(2.0 * a) == 2.0 * coeffs(a)

        @test coeffs(a / 2) == coeffs(a) / 2
        b = a / 2
        @test b isa AlgebraElement
        @test eltype(b) == typeof(1 / 2)
        @test coeffs(b / 2) == 0.25 * coeffs(a)

        c = a // 1

        @test eltype(c) == Rational{Int}
        @test c // 4 isa AlgebraElement
        @test c // big(4) isa AlgebraElement
        @test eltype(c // (big(4) // 1)) == Rational{BigInt}

        @test (1.0a) * 1 // 2 == (0.5a) == c // 2
    end

    @testset "Additive structure" begin
        sc = SA.SparseCoefficients(
            collect(SA.object(RG)),
            ones(Int, length(basis(RG))),
        )
        a = AlgebraElement(sc, RG)
        b = sum(sign(g) * RG(g) for g in G)

        @test a == sum(RG(g) for g in G)

        @test 1 / 2 * (coeffs(a + b)) == SA.SparseCoefficients(
            collect(SA.object(RG)),
            [1.0, 0.0, 1.0, 0.0, 1.0, 0.0],
        )

        g, h = PermutationGroups.gens(G)
        k = g * h

        a = RG(1) + RG(g) + RG(h)
        b = RG(1) - RG(k) - RG(h)

        @test a - b == RG(g) + RG(k) + 2RG(h)

        @test a + b - 2a == b - a
        @test (2a) // 2 == a
        @test a + 2a == 3.0a
        @test 2a - a // 1 == a
        @test div(3a, 2) == a

        @test coeffs(a + b - 2a) == coeffs(a) + coeffs(b) - 2coeffs(a)
        @test coeffs(2a // 2) == 2coeffs(a) // 2 == coeffs(a)
        @test coeffs(3a) == 3.0coeffs(a)
        @test coeffs(2a) - coeffs(a // 1) ==
              2coeffs(a) - coeffs(a) // 1 ==
              coeffs(a)
        @test div(3coeffs(a), 2) == coeffs(a)
    end

    @testset "Multiplicative structure" begin
        for g in G, h in G
            a = RG(g)
            b = RG(h)
            @test a * b == RG(g * h)
            @test (a + b) * (a + b) == a * a + a * b + b * a + b * b
        end

        for g in G
            @test star(RG(g)) == RG(inv(g))
            @test (one(RG) - RG(g)) * star(one(RG) - RG(g)) ==
                  2 * one(RG) - RG(g) - RG(inv(g))
            @test aug(one(RG) - RG(g)) == 0
        end

        g, h = PermutationGroups.gens(G)
        k = g * h

        a = RG(1) + RG(g) + RG(h)
        b = RG(1) - RG(k) - RG(h)

        @test norm(a) == norm(b)

        @test a * b == MA.operate_to!(similar(a), *, a, b)

        @test aug(a) == 3
        @test aug(b) == -1
        @test aug(a) * aug(b) == aug(a * b) == aug(b * a)

        z = sum((one(RG) - RG(g)) * star(one(RG) - RG(g)) for g in G)
        @test aug(z) == 0

        @test SA.supp(z) == sort(collect(basis(z)))
        @test SA.supp(RG(1) + RG(g)) == [one(G), g]
        @test SA.supp(a) == [one(G), h, g]

        @testset "Projections in star algebras" begin
            b = basis(RG)
            l = length(b)
            P = sum(RG(g) for g in b) // l
            @test P * P == P

            P3 = 2 * sum(RG(g) for g in b if sign(g) > 0) // l
            @test P3 * P3 == P3

            PAlt = sum(sign(g) * RG(g) for g in b) // l
            @test PAlt * PAlt == PAlt

            @test P3 * PAlt == PAlt * P3

            h = Permutation(perm"(2,3)", G)
            P2 = (RG(1) + RG(h)) // 2
            @test P2 * P2 == P2

            @test P2 * P3 == P3 * P2 == P

            P2m = (RG(1) - RG(h)) // 2
            @test P2m * P2m == P2m

            @test P2m * P3 == P3 * P2m == PAlt
            @test iszero(P2m * P2)

            @testset "Dense projections and Fixed basis" begin
                n = length(basis(RG))
                fb = SA.FixedBasis(basis(RG); n = n)
                fRG = StarAlgebra(SA.object(RG), fb)
                @testset "compatibility: sparse/dense" begin
                    fP = AlgebraElement(coeffs(P, basis(fRG)), fRG)
                    @test fP * fP == fP
                    dfP = AlgebraElement(fill(1 // n, n), fRG)
                    @test dfP == fP
                    @test dfP * dfP == dfP
                    @test fP * dfP == dfP
                    @test coeffs(fP * dfP) isa DenseArray

                    @test 2dfP // 2 == dfP

                    @test (dfP + fP) - dfP == dfP
                end

                @testset "Projections" begin
                    RG = fRG
                    b = basis(RG)
                    l = length(b)
                    P = sum(RG(g) for g in b) // l
                    @test P * P == P

                    P3 = 2 * sum(RG(g) for g in b if sign(g) > 0) // l
                    @test P3 * P3 == P3

                    PAlt = sum(sign(g) * RG(g) for g in b) // l
                    @test PAlt * PAlt == PAlt

                    @test P3 * PAlt == PAlt * P3

                    h = Permutation(perm"(2,3)", G)
                    P2 = (RG(1) + RG(h)) // 2
                    @test P2 * P2 == P2

                    @test P2 * P3 == P3 * P2 == P

                    @test -RG(h) == (-1) * RG(h)
                    @test !iszero(RG(1) - RG(h))

                    P2m = (RG(1) - RG(h)) // 2
                    @test P2m * P2m == P2m

                    @test P2m * P3 == P3 * P2m == PAlt
                    @test iszero(P2m * P2)
                end
            end
        end
    end
end

# This file is a part of StarAlgebras.jl. License is MIT: https://github.com/JuliaAlgebra/StarAlgebras.jl/blob/main/LICENSE
# Copyright (c) 2021-2025: Marek Kaluba, Benoît Legat

function _alloc_test(output, op, a, b, allocs)
    MA.operate_to!(output, op, a, b)
    MA.operate_to!(output, op, a, b)
    expected = op(a, b)
    @test @allocations(MA.operate_to!(output, op, a, b)) <= allocs
    @test output == expected
end

function _test_op(op, a, b)
    result = @inferred op(a, b)
    @test typeof(result) == MA.promote_operation(op, typeof(a), typeof(b))
    return result
end

@testset "FixedBasis caching && allocations" begin
    alph = [:a, :b, :c]
    A★ = FreeWords(alph)
    B = SA.DiracBasis(A★)

    fB = SA.FixedBasis(B; n = UInt32(nwords(A★, 8)))
    mt = UInt32(nwords(A★, 4))
    fRG = StarAlgebra(A★, SA.MTable(fB, (mt, mt)))

    k = size(SA.mstructure(fRG), 1)

    y = spzeros(length(basis(fRG)))
    y[1:k] .= 1
    Y = AlgebraElement(y, fRG)
    @test Y == sum(fRG(basis(fRG)[i]) for i in 1:k)

    @test Y isa AlgebraElement

    star(Y)
    star(Y)
    @test (@allocations star(Y)) ≤ 6

    @test SA.supp(Y) == basis(fRG)[1:k]

    @test Y * one(fRG) == Y
    @test one(fRG) * Y == Y

    @test_throws SA.UndefRefError all(!iszero, SA.mstructure(fRG).table)
    mstr = deepcopy(SA.mstructure(fRG))
    SA.complete!(mstr)
    @test all(!iszero(mstr.table))
    @test_throws SA.UndefRefError all(!iszero, SA.mstructure(fRG).table)

    @test (@allocations Y * Y) > 2(k^2 - 2 * k)
    @test Y * Y isa AlgebraElement
    res = SA._preallocate_output(*, Y, Y)
    @test @allocations(SA._preallocate_output(*, Y, Y)) ≤ 10
    MA.operate_to!(res, *, Y, Y) # makes sure res is of right size
    @test (@allocations MA.operate_to!(res, *, Y, Y)) ≤ 1

    @test all(!iszero, SA.mstructure(fRG).table)

    YY = deepcopy(Y)
    _alloc_test(YY, *, Y, Y, 0)
    _alloc_test(YY, +, Y, Y, 0)
    _alloc_test(YY, -, Y, Y, 0)

    # SparseArrays calls `Base.unalias` which allocates:
    _alloc_test(YY, +, YY, Y, 4)
    _alloc_test(YY, +, Y, YY, 4)
end

@testset "tuple" begin
    alph = [:a, :b, :c]
    A★ = FreeWords(alph)
    B = SA.DiracBasis(A★)

    fB = SA.FixedBasis(B; n = UInt32(nwords(A★, 2)))
    mt = UInt32(nwords(A★, 2))
    fRG = StarAlgebra(A★, SA.MTable(fB, (mt, mt)))

    y = SA.SparseCoefficients([first(fB)], [1])
    Y = AlgebraElement(y, fRG)

    z = SA.SparseCoefficients((first(fB),), (1,))
    Z = AlgebraElement(z, fRG)

    @test convert(typeof(SA.coeffs(Y)), SA.coeffs(Y)) === SA.coeffs(Y)
    @test convert(typeof(Y), Y) === Y
    @test convert(typeof(Y), Z) !== Z
    @test convert(typeof(Y), Z) isa typeof(Y)
    @test convert(typeof(Y), Z) == Z

    @test _test_op(+, Z, Z) == _test_op(*, 2, Z)
    @test _test_op(+, Z, Z) == _test_op(+, Y, Y)
    @test _test_op(+, Y, Z) == _test_op(+, Y, Y)
    @test _test_op(+, Z, Y) == _test_op(+, Y, Y)
    @test _test_op(-, Z, Z) == _test_op(*, 0, Z)
    @test _test_op(-, Z, Z) == _test_op(-, Y, Z)

    for X in [Y, Z]
        c = coeffs(X)
        res = 2 .* c
        @test c .* 2 == res
        @test c .+ 1 == res
        @test 1 .+ c == res
        @test MA.Zero() .+ c == c
        @test c .+ MA.Zero() == c
        err = ArgumentError(
            "Cannot broadcast `StarAlgebras.SparseCoefficients` with another array of different type",
        )
        @test_throws err c .+ ones(3)
    end
end

# This file is a part of StarAlgebras.jl. License is MIT: https://github.com/JuliaAlgebra/StarAlgebras.jl/blob/main/LICENSE
# Copyright (c) 2021-2025: Marek Kaluba, Benoît Legat

"""
    AbstractBasis{T,I}
Implements

 * `in(x, basis)` for basis elements
 * `Base.getindex(b::AbstractBasis{T,I}, idx::I)::T`
 * iteration protocol

`AbstractBasis` from the outside may look like a vector with arbitrary indices,
however it may be possibly infinite (and therefore does not define its length).

When `I<:Integer` one may store coefficients w.r.t. the basis in an ordinary
vector, however it's length has no relation to the size of the basis (which may
still be infinite).

* [`ImplicitBasis`](@ref) is best suited for bases which can be enumerated but
  are in princle infinite in size (e.g. monomial basis for the polynomial ring).
  An example implementation of [`DiracBasis`](@ref) wrapping an iterator can be
  used for this purpose.
* [`ExplicitBasis`](@ref) can be used for fixed, finite size bases, in particular
  [`FixedBasis`](@ref) implements `AbstractVector`-type storage for elements.
  This can be used e.g. for representing polynomials as (sparse) vectors of
  coefficients w.r.t. a given `FixedBasis`.
"""
abstract type AbstractBasis{T,I} end

Base.eltype(::Type{<:AbstractBasis{T}}) where {T} = T
Base.eltype(b::AbstractBasis) = eltype(typeof(b))
key_type(::Type{<:AbstractBasis{T,I}}) where {T,I} = I
key_type(b::AbstractBasis) = key_type(typeof(b))

"""
    abstract type ImplicitBasis{T,I} <: AbstractBasis{T,I} end

Implicit bases are bases that contains the product of all its elements.
This makes these bases particularly useful to work with [`AlgebraElement`](@ref)s with supports that can not be reasonably bounded.
Note that these bases may not explictly store its elements in memory as they may be potentially infinite.
The elements of the basis are iterated in increasing order according to `comparable(object(b))`.
"""
abstract type ImplicitBasis{T,I} <: AbstractBasis{T,I} end

comparable(::Type) = isless
comparable(object) = comparable(eltype(object))
comparable(b::ImplicitBasis) = comparable(object(b))

function zero_coeffs(::Type{S}, basis::ImplicitBasis{T,I}) where {S,T,I}
    return SparseCoefficients(I[], S[], comparable(basis))
end

"""
    abstract type ExplicitBasis{T,I<:Integer} <: AbstractBasis{T,I} end

Explicit bases are bases of finite length for which the keys are integers.
"""
abstract type ExplicitBasis{T,I<:Integer} <: AbstractBasis{T,I} end

Base.IteratorSize(::Type{<:ExplicitBasis}) = Base.HasLength()
Base.keys(eb::ExplicitBasis) = Base.OneTo(length(eb))
Base.size(eb::ExplicitBasis) = (length(eb),)

function zero_coeffs(::Type{S}, eb::ExplicitBasis{T,I}) where {S,T,I}
    return spzeros(S, I, length(eb))
end

function Base.getindex(
    eb::ExplicitBasis{T},
    range::AbstractRange{<:Integer},
) where {T}
    return T[eb[i] for i in range]
end

"""
    coeffs(cfs, source, target)
Translate coefficients `cfs` in `source::AbstractBasis` to basis
`target::AbstractBasis`.
"""
function coeffs(cfs, source::AbstractBasis, target::AbstractBasis)
    source === target && return cfs
    source == target && return cfs
    res = zero_coeffs(value_type(cfs), target)
    return coeffs!(res, cfs, source, target)
end

function coeffs!(res, cfs, source::AbstractBasis, target::AbstractBasis)
    MA.operate!(zero, res)
    for (k, v) in nonzero_pairs(cfs)
        x = source[k]
        res[target[x]] = v
    end
    return res
end

"""
    adjoint_coeffs(cfs, source, target)
Return `A' * cfs` where `A` is the linear map applied by
`coeffs`.
"""
function adjoint_coeffs(cfs, source::AbstractBasis, target::AbstractBasis)
    source === target && return cfs
    source == target && return cfs
    res = zero_coeffs(value_type(cfs), source)
    return adjoint_coeffs!(res, cfs, source, target)
end

function adjoint_coeffs!(res, cfs, source::AbstractBasis, target::AbstractBasis)
    MA.operate!(zero, res)
    for (k, v) in nonzero_pairs(cfs)
        x = target[k]
        # If `x` is not in `source` then the corresponding row in `A` is zero
        # so the column in `A'` is zero hence we can ignore it.
        if x in source
            res[source[x]] += v
        end
    end
    return res
end

# This file is a part of StarAlgebras.jl. License is MIT: https://github.com/JuliaAlgebra/StarAlgebras.jl/blob/main/LICENSE
# Copyright (c) 2021-2025: Marek Kaluba, Benoît Legat

"""
    abstract type AbstractCoefficients{K,V} end
Everything that implements a fixed set of methods can be used as
`SparseCoefficients` without subtyping it.

# "Read-only" coefficients
E.g. returned by calls to a `MultiplicativeStructure` need to implement

* `Base.keys`
* `Base.values`
* `StarAlgebras.canonical`
* `StarAlgebras.star(b::AbstractBasis, ac)`

For general types either all necessary arithmetic operations need to be
implemented, or fallbacks using the framework of `MutableArithmetics` are
provided based on random indexing. Additionally one needs to provide:

* `Base.similar(ac, T::Type)` with the same semantics as the one for vectors
* `Base.getindex(ac, idx)`
* `Base.setindex!(ac, val, idx)`
* `MutableArithmetics.operate!(ms::UnsafeAddMul, ac, v::C, w::C) where C<:SA.AbstractCoefficients`

"""
abstract type AbstractCoefficients{K,V} end

key_type(::Type{<:AbstractCoefficients{K}}) where {K} = K
value_type(::Type{<:AbstractCoefficients{K,V}}) where {K,V} = V
key_type(b::AbstractCoefficients) = key_type(typeof(b))
value_type(b::AbstractCoefficients) = value_type(typeof(b))

key_type(b) = keytype(b)
# `keytype(::Type{SparseVector{V,K}})` is not defined so it falls
# back to `keytype{::Type{<:AbstractArray})` which returns `Int`.
key_type(::Type{SparseArrays.SparseVector{V,K}}) where {V,K} = K
key_type(v::SparseArrays.SparseVector) = key_type(typeof(v))
key_type(::Tuple) = Int

value_type(coeffs) = valtype(coeffs)
# `valtype` is not defined for `Tuple` so we need to define
# our own function `value_type` as defining `valtype` for
# tuples would be type piracy
value_type(::Type{NTuple{N,T}}) where {N,T} = T
value_type(::NTuple{N,T}) where {N,T} = T

Base.iszero(ac::AbstractCoefficients) = isempty(keys(ac))

Base.similar(ac::AbstractCoefficients) = similar(ac, value_type(ac))

similar_type(::Type{<:Vector}, ::Type{T}) where {T} = Vector{T}
function similar_type(
    ::Type{<:SparseArrays.SparseVector{C,I}},
    ::Type{T},
) where {C,I,T}
    return SparseArrays.SparseVector{T,I}
end

"""
    canonical(ac::AbstractCoefficients)
Compute the canonical form of `ac` (e.g. grouping coefficients together, etc).

If `ac` can be brought to canonical form in-place one has to implement
* `MA.mutability(::Type{typeof(ac)}, canonical, ::Vararg{Type}) = MA.IsMutable()`
* `MA.operate!(canonical, ac)` that performs this canonicalization.

otherwise `canonical(ac)` needs to be implemented.
"""
function canonical end
function MA.promote_operation(::typeof(canonical), ::Type{C}) where {C}
    return C
end

# example implementation for vectors
MA.operate!(::typeof(canonical), sv::SparseVector) = dropzeros!(sv)
MA.operate!(::typeof(canonical), v::Vector) = v

function Base.:(==)(ac1::AbstractCoefficients, ac2::AbstractCoefficients)
    MA.operate!(canonical, ac1)
    MA.operate!(canonical, ac2)
    all(x -> ==(x...), zip(keys(ac1), keys(ac2))) || return false
    all(x -> ==(x...), zip(values(ac1), values(ac2))) || return false
    return true
end

function Base.hash(ac::AbstractCoefficients, h::UInt)
    MA.operate!(canonical, ac)
    return foldl((h, i) -> hash(i, h), nonzero_pairs(ac); init = h)
end

"""
    nonzero_pairs(ac::AbstractCoefficients)
Return an iterator over pairs `(k=>v)` of keys and values stored in `ac`.

The iterator contains all pairs with `v` potentially non-zero.
"""
@inline function nonzero_pairs(ac)
    return (k => v for (k, v) in zip(keys(ac), values(ac)))
end

@inline nonzero_pairs(v::AbstractVector) =
    (p for p in pairs(v) if !iszero(last(p)))
@inline function nonzero_pairs(v::AbstractSparseVector)
    return zip(SparseArrays.nonzeroinds(v), SparseArrays.nonzeros(v))
end

function LinearAlgebra.norm(sc::AbstractCoefficients, p::Real)
    isempty(values(sc)) && return (0^p)^(1 / p)
    return sum(abs(v)^p for v in values(sc))^(1 / p)
end

function LinearAlgebra.dot(ac::AbstractCoefficients, bc::AbstractCoefficients)
    if isempty(values(ac)) || isempty(values(bc))
        return zero(MA.promote_sum_mul(value_type(ac), value_type(bc)))
    else
        return sum(c * star(bc[i]) for (i, c) in nonzero_pairs(ac))
    end
end

function LinearAlgebra.dot(w::AbstractVector, ac::AbstractCoefficients)
    @assert key_type(ac) <: Integer
    if isempty(values(ac))
        return zero(MA.promote_sum_mul(eltype(w), value_type(ac)))
    else
        return sum(w[i] * v for (i, v) in nonzero_pairs(ac))
    end
end

function LinearAlgebra.dot(ac::AbstractCoefficients, w::AbstractVector)
    @assert key_type(ac) <: Integer
    if isempty(values(ac))
        return zero(MA.promote_sum_mul(eltype(w), value_type(ac)))
    else
        return sum(v * star(w[i]) for (i, v) in nonzero_pairs(ac))
    end
end

Base.zero(X::AbstractCoefficients) = MA.operate!(zero, similar(X))
Base.:-(X::AbstractCoefficients) = MA.operate_to!(__prealloc(X, -1, *), -, X)
Base.:*(X::AbstractCoefficients, a::Any) = a * X
Base.:/(X::AbstractCoefficients, a::Number) = inv(a) * X
Base.://(X::AbstractCoefficients, a::Number) = X * 1 // a

function Base.:*(a::Any, X::AbstractCoefficients)
    return MA.operate_to!(__prealloc(X, a, *), *, a, X)
end
function Base.:div(X::AbstractCoefficients, a::Number)
    return MA.operate_to!(__prealloc(X, a, div), div, X, a)
end
function Base.:+(X::AbstractCoefficients, Y::AbstractCoefficients)
    return MA.operate_to!(__prealloc(X, Y, +), +, X, Y)
end
function Base.:-(X::AbstractCoefficients, Y::AbstractCoefficients)
    return MA.operate_to!(__prealloc(X, Y, -), -, X, Y)
end

## fallbacks; require Base.setindex! implemented for AbstractCoefficients

function MA.operate!(::typeof(zero), X::AbstractCoefficients)
    for (idx, x) in nonzero_pairs(X)
        X[idx] = zero(x)
    end
    return X
end

# unary -
function MA.operate_to!(
    res::AbstractCoefficients,
    ::typeof(-),
    X::AbstractCoefficients,
)
    if res !== X
        MA.operate!(zero, res)
    end
    for (idx, x) in nonzero_pairs(X)
        res[idx] = -x
    end
    return res
end

# scalar
function MA.operate_to!(
    res::AbstractCoefficients,
    ::typeof(*),
    a::Any,
    X::AbstractCoefficients,
)
    if res !== X
        MA.operate!(zero, res)
    end
    for (idx, x) in nonzero_pairs(X)
        res[idx] = a * x
    end
    return res
end

function MA.operate_to!(
    res::AbstractCoefficients,
    ::typeof(div),
    X::AbstractCoefficients,
    a::Number,
)
    if res !== X
        MA.operate!(zero, res)
    end
    for (idx, x) in nonzero_pairs(X)
        res[idx] = div(x, a)
    end
    return res
end

# binary ops
function MA.operate_to!(
    res::AbstractCoefficients,
    ::typeof(+),
    X::AbstractCoefficients,
    Y::AbstractCoefficients,
)
    if res === X
        for (idx, y) in nonzero_pairs(Y)
            res[idx] += y
        end
    elseif res === Y
        for (idx, x) in nonzero_pairs(X)
            res[idx] += x
        end
    else
        MA.operate!(zero, res)
        for (idx, x) in nonzero_pairs(X)
            res[idx] += x
        end
        for (idx, y) in nonzero_pairs(Y)
            res[idx] += y
        end
    end
    return res
end

function MA.operate_to!(
    res::AbstractCoefficients,
    ::typeof(-),
    X::AbstractCoefficients,
    Y::AbstractCoefficients,
)
    if res === X
        for (idx, y) in nonzero_pairs(Y)
            X[idx] -= y
        end
    else
        if res !== Y
            MA.operate!(zero, res)
        end
        MA.operate_to!(res, -, Y)
        MA.operate_to!(res, +, res, X)
    end
    return res
end

__lmul(a, k) = a * k
__rmul(a, k) = k * a

function MA.operate_to!(
    res::AbstractCoefficients,
    mul::Union{typeof(__lmul),typeof(__rmul)},
    a,
    X::AbstractCoefficients,
)
    if res === X
        throw("No aliasing is allowed in shift")
    else
        MA.operate!(zero, res)
        for (k, v) in nonzero_pairs(X)
            res[mul(a, k)] += v
        end
    end
    return res
end

# This file is a part of StarAlgebras.jl. License is MIT: https://github.com/JuliaAlgebra/StarAlgebras.jl/blob/main/LICENSE
# Copyright (c) 2021-2025: Marek Kaluba, Benoît Legat

using Test
using LinearAlgebra
using SparseArrays

using StarAlgebras
import StarAlgebras as SA
import MutableArithmetics as MA

begin
    # turning GroupsCore.GroupElement into "read-only" SparseCoefficients
    import GroupsCore: GroupElement
    Base.keys(g::GroupElement) = (g,)
    Base.values(::GroupElement) = (1,)
    SA.canonical(g::GroupElement) = g
    # missing above: Base.isless for the SA.canonical
    # TODO: implement sort by hashing for non-comparable elements?

    # generalities for meaningful *-algebras
    SA.star(g::GroupElement) = inv(g)
end

for file in readdir(joinpath(@__DIR__, "..", "examples"))
    if endswith(file, ".jl")
        include(joinpath(@__DIR__, "..", "examples", file))
    end
end

# Test that `basis` implements the vector interface
# returns the same as `vector`
function test_vector_interface(basis, vector = collect(basis))
    @test length(basis) == length(vector)
    @test size(basis) == size(vector)
    @test eltype(basis) == eltype(vector)
    @test eltype(basis) == eltype(typeof(basis))
    @test last(basis) == last(vector)
    i = lastindex(basis)
    @test i == lastindex(vector)
    @test getindex(basis, i) == last(vector)
    @test first(basis) == first(vector)
    i = firstindex(basis)
    @test i == firstindex(vector)
    @test getindex(basis, i) == first(vector)
end

@testset "StarAlgebras" begin
    include("basic.jl")
    # proof of concept
    using PermutationGroups
    include("merge_sorted.jl")
    include("perm_grp_algebra.jl")

    include("constructors.jl")
    include("group_algebra.jl")
    include("abstract_coeffs.jl")

    # free monoid algebra
    include("monoid_algebra.jl")
    include("quadratic_form.jl")

    include("caching_allocations.jl")
    include("graded_lex.jl")

    # some applications:
    using Groups
    lexord(a, b) = isless(Groups.word(a), Groups.word(b))
    SA.comparable(::Type{<:Groups.FPGroupElement}) = lexord
    include("sum_of_squares.jl")
end

# This file is a part of StarAlgebras.jl. License is MIT: https://github.com/JuliaAlgebra/StarAlgebras.jl/blob/main/LICENSE
# Copyright (c) 2021-2025: Marek Kaluba, Benoît Legat

"""
    MTable{T, I} <: MultiplicativeStructure{T,I}
Multiplicative table, stored explicitly as an AbstractMatrix{I}.

!!! note
    Accessing `mt(i,j)` with negative indices returns the product of
    `star`ed basis elements, i.e.
    ```julia
    mt(-i, j) == b[star(b[i])*b[j]]
    ```
"""
struct MTable{
    T,
    I<:Integer,
    Ms<:MultiplicativeStructure{T,I},
    M<:AbstractMatrix,
} <: MultiplicativeStructure{T,I}
    mstr::Ms
    table::M
    lock::Base.Threads.SpinLock
end

function MTable(
    mstr::MultiplicativeStructure{T,I},
    dims::NTuple{2,I},
) where {T,I<:Integer}
    bas = basis(mstr)
    Base.require_one_based_indexing(bas)

    if Base.haslength(bas)
        @assert length(bas) ≥ first(dims)
        @assert length(bas) ≥ last(dims)
    end

    C = typeof(mstr(first(bas), first(bas)))
    table = Matrix{C}(undef, dims)
    # this is to avoid situation with allocated garbage in table
    # we want table to consist of #undefs as "sentiel values"
    @assert !isbitstype(C) || dims == (0, 0)

    return MTable(mstr, table, Base.Threads.SpinLock())
end

function MTable(
    basis::AbstractBasis{T,I},
    dims::NTuple{2,I},
) where {T,I<:Integer}
    return MTable(DiracMStructure(basis, *), dims)
end

Base.@propagate_inbounds function __absindex(mt::MTable, i::Integer)
    return ifelse(i > 0, i, oftype(i, star(mt, abs(i))))
end

Base.size(mt::MTable, i::Vararg) = size(mt.table, i...)
Base.getindex(mt::MTable, i::Integer) = mt.mstr[__absindex(mt, i)]
basis(mstr::MTable) = basis(mstr.mstr)

function __iscomputed(mt::MTable, i, j)
    return isassigned(mt.table, i, j)
end

function (mt::MTable{T,I})(x, y, ::Type{I}) where {T,I}
    return map_keys(Base.Fix1(getindex, mt), mt(x, y, T))
end

(mt::MTable{T,I})(x::Integer, y::Integer) where {T,I} = mt(x, y, I)

function (mt::MTable{T})(x::T, y::T, ::Type{U}) where {T,U}
    i = __absindex(mt, mt[x])
    j = __absindex(mt, mt[y])
    return mt(i, j, U)
end

function (mt::MTable{T})(i::Integer, j::Integer, ::Type{T}) where {T}
    if !checkbounds(Bool, mt.table, i, j)
        x, y = mt[i], mt[j]
        return mt.mstr(x, y)
    end
    if !__iscomputed(mt, i, j)
        lock(mt.lock) do
            return thread_unsafe_complete!(mt, i, j)
        end
    end

    # TODO remove for v1.12 https://github.com/JuliaLang/julia/pull/54707
    res = mt.table[i, j] # load
    while res != mt.table[i, j] # compare
        res = mt.table[i, j] # and load again
        yield()
    end

    return mt.table[i, j] # and load again
end

function thread_unsafe_complete!(mt::MTable, i::Integer, j::Integer)
    g, h = mt[i], mt[j]
    gh_cfs = mt.mstr(g, h)
    # TODO use atomic for v1.12 https://github.com/JuliaLang/julia/pull/54707
    #      but then we'll have to use `AtomicMemory`
    mt.table[i, j] = gh_cfs
    return mt
end

function complete!(mt::MTable)
    Threads.@threads for j in axes(mt.table, 2)
        for i in axes(mt.table, 1)
            @inbounds thread_unsafe_complete!(mt, i, j)
        end
    end
    return mt
end

function MA.operate!(
    ms::UnsafeAddMul{<:MTable},
    res::AbstractSparseVector,
    v::AbstractVector,
    w::AbstractVector,
)
    l1 = issparse(v) ? nnz(v) : 2^8
    l2 = issparse(w) ? nnz(w) : 2^8
    l = l1 * l2
    idcs = Vector{key_type(res)}()
    vals = Vector{eltype(res)}()
    sizehint!(idcs, l)
    sizehint!(vals, l)

    for (kv, a) in nonzero_pairs(v)
        for (kw, b) in nonzero_pairs(w)
            c = ms.structure(kv, kw)
            for (k, v) in nonzero_pairs(c)
                push!(idcs, ms.structure[k])
                push!(vals, v * a * b)
            end
        end
    end
    res .+= sparsevec(idcs, vals, length(res))
    return res
end

# TODO promote_with_map

function promote_bases_with_maps(a::MTable, b::MTable)
    _a, _b = promote_bases_with_maps(a.mstr, b.mstr)
    return maybe_promote(a, _a...), maybe_promote(b, _b...)
end

# This file is a part of StarAlgebras.jl. License is MIT: https://github.com/JuliaAlgebra/StarAlgebras.jl/blob/main/LICENSE
# Copyright (c) 2021-2025: Marek Kaluba, Benoît Legat

struct Wrap{T}
    x::T
end
Base.:*(a::Wrap, b::Wrap) = Wrap(a.x * b.x)

wrap(x) = Wrap(x)
unwrap(w::Wrap) = w.x

@testset "Abstract coefficients" begin
    G = PermGroup(perm"(1,2,3)", perm"(1,2)")
    RG = StarAlgebra(G, SA.DiracBasis(G))
    wRG = StarAlgebra(G, SA.MappedBasis(G, wrap, unwrap))

    for basis in [RG, wRG]
        A = SA.AlgebraElement(
            SA.SparseCoefficients(collect(G), Float64.(1:6)),
            basis,
        )
        B = SA.AlgebraElement(
            SA.SparseCoefficients(collect(G)[2:2], [-1]),
            basis,
        )
        @test (A - B)^2 == A^2 - A * B - B * A + B^2
    end

    fRG = let RG = RG, n = UInt32(length(basis(RG)))
        fb = SA.FixedBasis(basis(RG); n = n)
        StarAlgebra(SA.object(RG), fb)
    end

    h = Permutation(perm"(2,3)", G)

    α, β = let a = fRG(1), b = fRG(h)
        x = AlgebraElement(ACoeffs(coeffs(a, basis(fRG))), fRG)
        y = AlgebraElement(ACoeffs(coeffs(b, basis(fRG))), fRG)
        x, y
    end
    @test coeffs(α - β, SA.FixedBasis(basis(RG); n = 2)) == [1, -1]
    @test_throws KeyError coeffs(α - β, SA.FixedBasis(basis(RG); n = 1))
    @test SA.adjoint_coeffs(α - β, SA.FixedBasis(basis(RG); n = 2)) == [1, -1]
    @test SA.adjoint_coeffs(α - β, SA.FixedBasis(basis(RG); n = 1)) == [1]
    @test coeffs(2α) isa ACoeffs{Int}
    @test coeffs(α - β) isa ACoeffs
    @test coeffs(α - β // 3) isa ACoeffs{<:Rational}
    @test 3(α // 3) == α

    l = length(basis(RG))
    P = sum(RG(g) for g in basis(RG)) // l
    fP = AlgebraElement(ACoeffs(coeffs(P, basis(fRG))), fRG)
    @test AlgebraElement(coeffs(fP, basis(RG)), RG) == P
    @test fP * fP == fP

    fP2 = (α + β) // 2
    @test coeffs(fP2) isa ACoeffs{<:Rational}

    @test SA.key_type(coeffs(fP2)) == UInt32
    @test zero(coeffs(fP2)) == ACoeffs(coeffs(zero(P), basis(fRG)))

    P3 = 2 * sum(RG(g) for g in basis(RG) if sign(g) > 0) // l
    fP3 = AlgebraElement(ACoeffs(coeffs(P3, basis(fRG))), fRG)
    @test AlgebraElement(coeffs(fP3, basis(RG)), RG) == P3
    @test fP3 * fP3 == fP3

    PAlt = sum(sign(g) * RG(g) for g in basis(RG)) // l
    fPAlt = AlgebraElement(ACoeffs(coeffs(PAlt, basis(fRG))), fRG)
    @test AlgebraElement(coeffs(fPAlt, basis(RG)), RG) == PAlt
    @test fPAlt * fPAlt == fPAlt

    @test fP3 * fPAlt == fPAlt * fP3

    @test fP2 * fP2 == fP2

    @test fP2 * fP3 == fP3 * fP2 == fP

    P2m = (RG(1) - RG(h)) // 2
    fP2m = AlgebraElement(ACoeffs(coeffs(P2m, basis(fRG))), fRG)
    @test fP2m * fP2m == fP2m

    @test fP2m * fP3 == fP3 * fP2m == fPAlt
    @test iszero(fP2m * fP2)

    @test norm(fP2m) == norm(P2m) == norm(fP2m)
    v = coeffs(P2m, basis(fRG)) # an honest vector
    @test dot(fP2m, fP2m) == dot(coeffs(fP2m), v) == dot(v, coeffs(fP2m))

    s1, s2 = PermutationGroups.gens(G)
    @assert s1 * s2 ≠ s2 * s1
    Z = RG(1) + RG(s1)
    @test s2 * Z == RG(s2) + RG(s2 * s1)
    @test Z * s2 == RG(s2) + RG(s1 * s2)
end

# This file is a part of StarAlgebras.jl. License is MIT: https://github.com/JuliaAlgebra/StarAlgebras.jl/blob/main/LICENSE
# Copyright (c) 2021-2025: Marek Kaluba, Benoît Legat

module StarAlgebras

using SparseArrays
import LinearAlgebra

import MutableArithmetics as MA

export StarAlgebra, AlgebraElement
export basis, coeffs, star

function star end

# AbstractCoefficients
## abstract definitions
include("coefficients.jl")
## concrete implementation
include("sparse_coeffs.jl")

# AbstractBases
## abstract definitions
include("bases.jl")
# concrete implementations
include("bases_dirac.jl")
include("bases_fixed.jl")

# MultiplicativeStructures
include("mstructures.jl")
include("mtables.jl")

# Algebras and elts
include("types.jl")
include("algebra_elts.jl")
include("star.jl")

include("arithmetic.jl")
include("quadratic_form.jl")
include("show.jl")

include("merge_sorted.jl")

end

# This file is a part of StarAlgebras.jl. License is MIT: https://github.com/JuliaAlgebra/StarAlgebras.jl/blob/main/LICENSE
# Copyright (c) 2021-2025: Marek Kaluba, Benoît Legat

# Example implementation of a Gram matrix that relies on `StarAlgebras.QuadraticForm` for interacting with
# `StarAlgebras.AlgebraElement`s.
struct Gram{T,B}
    matrix::T
    basis::B
end

function Base.eltype(g::Gram)
    T = eltype(g.matrix)
    basis_eltype = eltype(basis(g))
    U = if basis_eltype <: SA.AlgebraElement
        # We will multiply with the coefficients of these `AlgebraElement`
        promote_type(T, eltype(basis_eltype))
    else
        # We will multiply with the basis elements which will be keys of
        # the `SparseCoefficients` so we won't multiply with any other coefficient
        T
    end
    return MA.promote_operation(+, U, U)
end

SA.basis(g::Gram) = g.basis
Base.getindex(g::Gram, i, j) = g.matrix[i, j]

# This file is a part of StarAlgebras.jl. License is MIT: https://github.com/JuliaAlgebra/StarAlgebras.jl/blob/main/LICENSE
# Copyright (c) 2021-2025: Marek Kaluba, Benoît Legat

# This file tests the implementation of a Chebyshev basis using MappedBasis.

# Define a struct to represent a Chebyshev polynomials
struct ChebyPoly
    n::Int
end

function Base.isless(a::ChebyPoly, b::ChebyPoly)
    return a.n < b.n
end

SA.star(a::ChebyPoly) = a

struct ChebyMStruct{T,I,B<:SA.AbstractBasis{T,I}} <: SA.MultiplicativeStructure{T,I}
    basis::B
end

function (m::ChebyMStruct)(a::ChebyPoly, b::ChebyPoly, ::Type{U}) where {U}
    return m(a.n, b.n, U)
end

function (m::ChebyMStruct)(a::Int, b::Int, ::Type{ChebyPoly})
    return SA.map_keys(Base.Fix1(getindex, m), m(a, b, Int))
end

function (m::ChebyMStruct)(a::Int, b::Int, ::Type{Int})
    return SA.SparseCoefficients(
        (abs(a - b), a + b),
        (1 // 2, 1 // 2),
    )
end

# Define the mapping from `Int` to `ChebyPoly`
function map_to_chebyshev(n::Int)
    return ChebyPoly(n)
end

# Define the inverse mapping from `ChebyPoly`s to `NaturalNumber`
function map_from_chebyshev(p::ChebyPoly)
    return p.n
end

# Create a `MappedBasis` that maps `NaturalNumbers` to `ChebyPoly`s
function cheby_basis()
    return SA.MappedBasis(NaturalNumbers(), map_to_chebyshev, map_from_chebyshev)
end

# This file is a part of StarAlgebras.jl. License is MIT: https://github.com/JuliaAlgebra/StarAlgebras.jl/blob/main/LICENSE
# Copyright (c) 2021-2025: Marek Kaluba, Benoît Legat

using SparseArrays, StarAlgebras

struct PlaceholderObject end
Base.one(::PlaceholderObject) = 1

# This corresponds to an object for which `+(::Variable, ::Variable)`
# is not a `Variable`. Think of `JuMP.VariableRef` or
# `MathOptInterface.VariableIndex`
struct Variable end
Base.iszero(::Variable) = false
# SparseArrays uses `v != zero(eltype(v))` instead of `iszero(v)`
# so we need to define this workaround...
Base.zero(::Type{Variable}) = 0

struct DummyBasis{T} <: SA.ExplicitBasis{T,Int}
    elements::Vector{T}
end

Base.:(==)(b1::DummyBasis, b2::DummyBasis) = b1.elements == b2.elements
Base.length(b::DummyBasis) = length(b.elements)
Base.getindex(b::DummyBasis, i::Int) = b.elements[i]
Base.iterate(b::DummyBasis, args...) = iterate(b.elements, args...)

@testset "Basic tests" begin
    b = DummyBasis(Irrational[π, ℯ])
    a = StarAlgebra(PlaceholderObject(), b)
    s(i) = sprint(show, MIME"text/plain"(), i)
    @test sprint(show, AlgebraElement([2, -1], a)) == "2·$(s(π)) - 1·$(s(ℯ))"
    @test a == a
    @test a !== StarAlgebra(PlaceholderObject(), DummyBasis(Irrational[π, ℯ]))
    @test a == StarAlgebra(PlaceholderObject(), DummyBasis(Irrational[π, ℯ]))
    @test AlgebraElement([2, -1], a) !== AlgebraElement(
        [2, -1],
        StarAlgebra(PlaceholderObject(), DummyBasis(Irrational[π, ℯ])),
    )
    @test AlgebraElement([2, -1], a) == AlgebraElement(
        [2, -1],
        StarAlgebra(PlaceholderObject(), DummyBasis(Irrational[π, ℯ])),
    )
    @test a != StarAlgebra(1, b)
    b2 = DummyBasis(Irrational[π, Irrational{:γ}()])
    @test a != StarAlgebra(PlaceholderObject(), b2)

    m = SA.MappedBasis(b, float, error)
    m2 = SA.MappedBasis(b2, float, error)
    A = StarAlgebra(1.0, m)
    A2 = StarAlgebra(1.0, m2)
    @test A == StarAlgebra(1.0, m)
    @test A == StarAlgebra(1.0, SA.MappedBasis(b, float, error))
    @test A != StarAlgebra(1.0, m2)

    sub = SA.sub_basis(m, Irrational[π])
    B = StarAlgebra(1.0, sub)
    @test B == B
    @test B == StarAlgebra(1.0, SA.sub_basis(m, Irrational[π]))
    @test B != StarAlgebra(1.0, SA.sub_basis(m, Irrational[ℯ]))
    @test B != StarAlgebra(1.0, SA.sub_basis(m2, Irrational[π]))
    π_ℯ = SA.sub_basis(m, Irrational[π, ℯ])
    @test B == StarAlgebra(1.0, SA.sub_basis(π_ℯ, 1:1))
    @test B == StarAlgebra(1.0, SA.sub_basis(π_ℯ, 1:1))
    @test B == StarAlgebra(1.0, SA.sub_basis(π_ℯ, [true, false]))
    @test B != StarAlgebra(1.0, SA.sub_basis(π_ℯ, 1:2))
    @test B != StarAlgebra(1.0, SA.sub_basis(π_ℯ, 2:2))
    err = ArgumentError(
        "`sub_basis` expects indices to be sorted but the given indices `$([2, 1])` are not sorted",
    )
    @test_throws err StarAlgebra(1.0, SA.sub_basis(π_ℯ, [2, 1]))

    el = SA.AlgebraElement([Variable()], StarAlgebra(1.0, SA.FixedBasis([2.0])))
    coeffs23 = SA.coeffs(el, SA.FixedBasis([2.0, 3.0]))
    @test coeffs23 == sparsevec([1], [Variable()], 2)

    z = zero(Variable, A)
    # `zero(Variable} isa Int` but it shouldn't affect the type of `AlgebraElement`
    @test z isa SA.AlgebraElement{Variable}
    @test iszero(z)
end

# This file is a part of StarAlgebras.jl. License is MIT: https://github.com/JuliaAlgebra/StarAlgebras.jl/blob/main/LICENSE
# Copyright (c) 2021-2025: Marek Kaluba, Benoît Legat

Base.hash(a::AlgebraElement, h::UInt) = hash(coeffs(a), hash(parent(a), h))

function Base.:(==)(X::AlgebraElement, Y::AlgebraElement)
    parent(X) == parent(Y) || return false
    return coeffs(X) == coeffs(Y)
end

Base.copy(a::AlgebraElement) = AlgebraElement(copy(coeffs(a)), parent(a))

function Base.deepcopy_internal(a::AlgebraElement, id::IdDict)
    if !haskey(id, a)
        id[a] = AlgebraElement(Base.deepcopy_internal(coeffs(a), id), parent(a))
    end
    return id[a]
end

# call overload:
(a::AlgebraElement)(x) = coeffs(a)[basis(a)[x]]
Base.setindex!(a::AlgebraElement, v, idx) = a.coeffs[basis(a)[idx]] = v

# AlgebraElement specific functions

function supp(a::AlgebraElement)
    b = basis(a)
    return [b[i] for (i, _) in nonzero_pairs(coeffs(a))]
end

function LinearAlgebra.norm(a::AlgebraElement, p::Real = 2)
    return LinearAlgebra.norm(coeffs(a), p)
end

function LinearAlgebra.dot(a::AlgebraElement, b::AlgebraElement)
    return LinearAlgebra.dot(coeffs(a), coeffs(b))
end

function LinearAlgebra.dot(w::AbstractVector, b::AlgebraElement)
    return LinearAlgebra.dot(w, coeffs(b))
end
function LinearAlgebra.dot(a::AlgebraElement, w::AbstractVector)
    @assert key_type(basis(parent(a))) <: Integer
    return LinearAlgebra.dot(coeffs(a), w)
end

"""
    promote_object(object, mstructure, map)

Promote the `object` field of a `StarAlgebra` to the new
multiplicative structure `mstructure` and the key map `map`.
"""
function promote_object end

"""
    maybe_promote(a, parent, map)

Promote `a` given the promoted parent `parent` and the key map
`map`. Call this function as follows:

    maybe_promote(a, ::Nothing)

Just return `a` in case there is no promotion to do.

To be used as follows
```julia
function promote_bases_with_maps(a::..., b::...)
    _a, _b = promote_bases_with_maps(parent(a), parent(b))
    return maybe_promote(a, _a...), maybe_promote(b, _b...)
end
```
"""
function maybe_promote end

maybe_promote(a, _, ::Nothing) = a, nothing
maybe_promote(a, b, map) = promote_with_map(a, b, map)

"""
    promote_with_map(a, parent, map)

Promote `a` given the promoted parent `parent` and the key map
`map. Implement this function but call `maybe_promote`.
"""
function promote_with_map end

function promote_with_map(a::StarAlgebra, mstr, map)
    new_obj = promote_object(object(a), mstr, map)
    return StarAlgebra(new_obj, mstr), map
end

"""
    promote_bases_with_map(a, b)

Return `(new_a, map_a), (new_b, map_b)` where `new_a` and `new_b`
are the promoted version of `a` and `b` so that they now have the same basis.
The function `map_a` (resp. `map_b`) maps the key of `a` (resp. `b`) to the
corresponding key of `new_a` (resp. `new_b`).

The convention for implementing this interface for a type `A` with parent type `B`
and function `parent` that obtains the parent type is as follows:
```julia
import StarAlgebras as SA

function SA.promote_with_map(a::A, b::B, map)
    # Promote other fields of `a` using `b` and `map`...
    return A(b, ...)
end

function SA.promote_bases_with_maps(a::A, b::A)
    _a, _b = SA.promote_bases_with_maps(parent(a), parent(b))
    return SA.maybe_promote(a, _a...), SA.maybe_promote(b, _b...)
end

function SA.promote_bases_with_maps(a::A, b::B)
    _a, _b = SA.promote_bases_with_maps(parent(a), b)
    return SA.maybe_promote(a, _a...), _b
end
```
"""
function promote_bases_with_maps end

function promote_bases_with_maps(a::StarAlgebra, b::StarAlgebra)
    _a, _b = promote_bases_with_maps(mstructure(a), mstructure(b))
    return maybe_promote(a, _a...), maybe_promote(b, _b...)
end

function promote_bases_with_maps(
    a::StarAlgebra,
    b::Union{MultiplicativeStructure,AbstractBasis},
)
    _a, _b = promote_bases_with_maps(mstructure(a), b)
    return maybe_promote(a, _a...), _b
end

function promote_with_map(a::AlgebraElement, alg, map)
    c = coeffs(a)
    if map !== identity
        c = map_keys(map, c)
    end
    return AlgebraElement(c, alg), map
end

function promote_bases_with_maps(a::AlgebraElement, b::AlgebraElement)
    _a, _b = promote_bases_with_maps(parent(a), parent(b))
    return maybe_promote(a, _a...), maybe_promote(b, _b...)
end

function promote_bases_with_maps(
    a::AlgebraElement,
    b::Union{StarAlgebra,MultiplicativeStructure,AbstractBasis},
)
    _a, _b = promote_bases_with_maps(parent(a), b)
    return maybe_promote(a, _a...), _b
end

"""
    promote_bases(a, b)

Same as `promote_bases_with_maps` but without the key maps.
"""
function promote_bases(a, b)
    _a, _b = promote_bases_with_maps(a, b)
    return _a[1], _b[1]
end

@testset "merge_sorted" begin
    dedup_kw = (; combine = SA.first_of, filter = _ -> true)
    @testset "Vector dedup merge" begin
        # Disjoint sorted vectors
        @test SA.merge_sorted([1, 3, 5], [2, 4, 6]; lt = isless, dedup_kw...) ==
              [1, 2, 3, 4, 5, 6]

        # Overlapping sorted vectors
        @test SA.merge_sorted([1, 3, 5], [3, 5, 7]; lt = isless, dedup_kw...) ==
              [1, 3, 5, 7]

        # Identical vectors
        @test SA.merge_sorted([1, 2, 3], [1, 2, 3]; lt = isless, dedup_kw...) ==
              [1, 2, 3]

        # One empty
        @test SA.merge_sorted(Int[], [1, 2, 3]; lt = isless, dedup_kw...) ==
              [1, 2, 3]
        @test SA.merge_sorted([1, 2, 3], Int[]; lt = isless, dedup_kw...) ==
              [1, 2, 3]

        # Both empty
        @test SA.merge_sorted(Int[], Int[]; lt = isless, dedup_kw...) == Int[]

        # Single elements
        @test SA.merge_sorted([1], [2]; lt = isless, dedup_kw...) == [1, 2]
        @test SA.merge_sorted([2], [1]; lt = isless, dedup_kw...) == [1, 2]
        @test SA.merge_sorted([1], [1]; lt = isless, dedup_kw...) == [1]

        # Custom lt (reverse order)
        @test SA.merge_sorted([5, 3, 1], [4, 2]; lt = >, dedup_kw...) ==
              [5, 4, 3, 2, 1]
        @test SA.merge_sorted([5, 3, 1], [5, 2]; lt = >, dedup_kw...) ==
              [5, 3, 2, 1]

        # Mixed element types
        @test SA.merge_sorted([1, 3], [2.0, 4.0]; lt = isless, dedup_kw...) ==
              [1.0, 2.0, 3.0, 4.0]
    end

    @testset "Vector combine merge" begin
        # Combine duplicate keys by summing
        v1 = [1, 3, 5]
        v2 = [3, 5, 7]
        result = SA.merge_sorted(
            v1,
            v2;
            lt = isless,
            combine = +,
            filter = x -> !iszero(x),
        )
        @test result == [1, 6, 10, 7]

        # Filter zeros
        v1 = [1, 2, 3]
        v2 = [2, 3, 4]
        result = SA.merge_sorted(
            v1,
            v2;
            lt = isless,
            combine = +,
            filter = x -> x < 6,
        )
        @test result == [1, 4, 4]  # 2+2=4 kept, 3+3=6 filtered, 4 kept

        # No filter (keep all)
        result = SA.merge_sorted(
            v1,
            v2;
            lt = isless,
            combine = +,
            filter = _ -> true,
        )
        @test result == [1, 4, 6, 4]
    end

    @testset "In-place merge_sorted!" begin
        result = Vector{Int}(undef, 6)
        SA.merge_sorted!(
            result,
            [1, 3, 5],
            [2, 4, 6];
            lt = isless,
            combine = +,
            filter = x -> !iszero(x),
        )
        @test result == [1, 2, 3, 4, 5, 6]

        result = Vector{Int}(undef, 6)
        SA.merge_sorted!(
            result,
            [1, 3, 5],
            [3, 5, 7];
            lt = isless,
            combine = +,
            filter = x -> !iszero(x),
        )
        @test result == [1, 6, 10, 7]
    end

    @testset "Tuple dedup merge" begin
        # Disjoint
        @test SA.merge_sorted((1, 3, 5), (2, 4, 6); lt = isless, dedup_kw...) ==
              (1, 2, 3, 4, 5, 6)

        # Overlapping
        @test SA.merge_sorted((1, 3, 5), (3, 5, 7); lt = isless, dedup_kw...) ==
              (1, 3, 5, 7)

        # Identical
        @test SA.merge_sorted((1, 2, 3), (1, 2, 3); lt = isless, dedup_kw...) ==
              (1, 2, 3)

        # One empty
        @test SA.merge_sorted((), (1, 2, 3); lt = isless, dedup_kw...) ==
              (1, 2, 3)
        @test SA.merge_sorted((1, 2, 3), (); lt = isless, dedup_kw...) ==
              (1, 2, 3)

        # Both empty
        @test SA.merge_sorted((), (); lt = isless, dedup_kw...) == ()

        # Single elements
        @test SA.merge_sorted((1,), (2,); lt = isless, dedup_kw...) == (1, 2)
        @test SA.merge_sorted((2,), (1,); lt = isless, dedup_kw...) == (1, 2)
        @test SA.merge_sorted((1,), (1,); lt = isless, dedup_kw...) == (1,)

        # Custom lt (reverse order)
        @test SA.merge_sorted((5, 3, 1), (4, 2); lt = >, dedup_kw...) ==
              (5, 4, 3, 2, 1)
        @test SA.merge_sorted((5, 3, 1), (5, 2); lt = >, dedup_kw...) ==
              (5, 3, 2, 1)
    end

    @testset "Vector rev keyword" begin
        # rev=true with default isless reverses the order
        @test SA.merge_sorted(
            [5, 3, 1],
            [4, 2];
            lt = isless,
            rev = true,
            dedup_kw...,
        ) == [5, 4, 3, 2, 1]
        @test SA.merge_sorted(
            [5, 3, 1],
            [5, 2];
            lt = isless,
            rev = true,
            dedup_kw...,
        ) == [5, 3, 2, 1]

        # rev=true with combine
        result = SA.merge_sorted(
            [5, 3, 1],
            [3, 1];
            lt = isless,
            rev = true,
            combine = +,
            filter = _ -> true,
        )
        @test result == [5, 6, 2]

        # rev=false is the default behavior
        @test SA.merge_sorted(
            [1, 3, 5],
            [2, 4, 6];
            lt = isless,
            rev = false,
            dedup_kw...,
        ) == [1, 2, 3, 4, 5, 6]
    end

    @testset "In-place rev keyword" begin
        result = Vector{Int}(undef, 5)
        SA.merge_sorted!(
            result,
            [5, 3, 1],
            [4, 2];
            lt = isless,
            rev = true,
            combine = SA.first_of,
            filter = _ -> true,
        )
        @test result == [5, 4, 3, 2, 1]
    end

    @testset "Tuple combine merge" begin
        @test SA.merge_sorted(
            (1, 3, 5),
            (3, 5, 7);
            lt = isless,
            combine = +,
            filter = _ -> true,
        ) == (1, 6, 10, 7)
        # Filter
        @test SA.merge_sorted(
            (1, 3, 5),
            (3, 5, 7);
            lt = isless,
            combine = +,
            filter = x -> x < 10,
        ) == (1, 6, 7)
    end

    @testset "Tuple rev keyword" begin
        @test SA.merge_sorted(
            (5, 3, 1),
            (4, 2);
            lt = isless,
            rev = true,
            dedup_kw...,
        ) == (5, 4, 3, 2, 1)
        @test SA.merge_sorted(
            (5, 3, 1),
            (5, 2);
            lt = isless,
            rev = true,
            dedup_kw...,
        ) == (5, 3, 2, 1)

        # rev=true with combine
        @test SA.merge_sorted(
            (5, 3, 1),
            (3, 1);
            lt = isless,
            rev = true,
            combine = +,
            filter = _ -> true,
        ) == (5, 6, 2)
    end

    @testset "multi_findsorted" begin
        # All found
        @test SA.multi_findsorted([1, 2, 3], [1, 2, 3]) == [1, 2, 3]

        # Superset x, subset y
        @test SA.multi_findsorted([1, 2, 3, 4, 5], [2, 4]) == [0, 1, 0, 2, 0]

        # Subset x, superset y
        @test SA.multi_findsorted([2, 4], [1, 2, 3, 4, 5]) == [2, 4]

        # Disjoint
        @test SA.multi_findsorted([1, 3, 5], [2, 4, 6]) == [0, 0, 0]

        # Empty x
        @test SA.multi_findsorted(Int[], [1, 2, 3]) == Int[]

        # Empty y
        @test SA.multi_findsorted([1, 2, 3], Int[]) == [0, 0, 0]

        # Custom lt (reverse order)
        @test SA.multi_findsorted([5, 3, 1], [5, 4, 3, 2, 1]; lt = >) ==
              [1, 3, 5]
    end

    @testset "merge_bases_with_maps" begin
        using PermutationGroups
        G = PermGroup(perm"(1,2,3)", perm"(1,2)")
        db = SA.DiracBasis(G)
        elts = sort(collect(G))

        b1 = SA.SubBasis(db, elts[1:3])
        b2 = SA.SubBasis(db, elts[2:5])
        @test b1.is_sorted
        @test b2.is_sorted

        merged, I1, I2 = SA.merge_bases_with_maps(b1, b2)
        @test length(merged) == 5
        @test merged.keys == elts[1:5]

        # Check index mapping: I1[i] = index of merged[i] in b1, 0 if absent
        for i in eachindex(I1)
            if I1[i] != 0
                @test merged.keys[i] == b1.keys[I1[i]]
            end
        end
        for i in eachindex(I2)
            if I2[i] != 0
                @test merged.keys[i] == b2.keys[I2[i]]
            end
        end

        # Disjoint bases
        b3 = SA.SubBasis(db, elts[1:2])
        b4 = SA.SubBasis(db, elts[4:6])
        merged2, I3, I4 = SA.merge_bases_with_maps(b3, b4)
        @test length(merged2) == 5
        @test all(==(0), I3[3:5])
        @test all(==(0), I4[1:2])
        @test merged2 == SA.merge_bases(b3, b4)

        # Identical bases
        merged3, I5, I6 = SA.merge_bases_with_maps(b1, b1)
        @test merged3.keys == b1.keys
        @test I5 == I6 == collect(1:length(b1))
    end
end

# This file is a part of StarAlgebras.jl. License is MIT: https://github.com/JuliaAlgebra/StarAlgebras.jl/blob/main/LICENSE
# Copyright (c) 2021-2025: Marek Kaluba, Benoît Legat

# Without these two function barriers, we get allocations on Julia v1.12.0-rc2
function minus_allocated_test(a, d)
    @test @allocated(MA.operate_to!(d, -, a)) == 0
end

function prod_2_allocated_test(a, d)
    @test @allocated(MA.operate_to!(d, *, 2, a)) == 0
end

@testset "Free monoid algebra" begin
    alph = [:a, :b, :c]
    A★ = FreeWords(alph)
    B = SA.DiracBasis(A★)
    RG = StarAlgebra(A★, B)
    @test basis(RG) === B

    # no caching
    fB = SA.FixedBasis(basis(RG); n = nwords(A★, 0, 8))

    fRG = StarAlgebra(A★, fB)

    g = one(fRG)
    @test isone(g)

    @test one(fRG) == g
    @test iszero(zero(fRG))
    @test zero(g) == zero(fRG)
    @test iszero(0 * g)
    @test isone(*(g, g, g))

    @testset "Translations between bases" begin
        Z = zero(RG)
        fZ = zero(fRG)

        @test coeffs(fZ) isa SparseVector

        @test coeffs(Z, fB) == coeffs(fZ)
        @test coeffs(fZ, B) == coeffs(Z)
        @test coeffs(coeffs(fZ, B), B, fB) == coeffs(fZ)
        @test coeffs(coeffs(Z, fB), fB, B) == coeffs(Z)

        let g = basis(fRG)[rand(1:121)]
            X = RG(g)
            Y = -RG(star(g))
            for i in 1:3
                coeffs(X)[basis(fRG)[rand(1:121)]] += rand(-3:3)
                coeffs(Y)[basis(fRG)[rand(1:121)]] -= rand(3:3)
            end

            @test coeffs(X) ==
                  coeffs(coeffs(X, basis(fRG)), basis(fRG), basis(RG))
            @test coeffs(Y) ==
                  coeffs(coeffs(Y, basis(fRG)), basis(fRG), basis(RG))

            fX = AlgebraElement(coeffs(X, basis(fRG)), fRG)
            fY = AlgebraElement(coeffs(Y, basis(fRG)), fRG)

            @test dot(X, Y) == dot(fX, fY) == dot(coeffs(X), coeffs(Y))
            @test dot(fX, coeffs(fY)) == dot(coeffs(fX), fY)

            @test dot(X, X) ≈ norm(X)^2 ≈ dot(coeffs(X), coeffs(X))
            @test dot(fX, fX) ≈ norm(fX)^2 ≈ dot(coeffs(fX), coeffs(fX))

            @test coeffs(fX) ==
                  coeffs(coeffs(fX, basis(RG)), basis(RG), basis(fRG))
            @test coeffs(fY) ==
                  coeffs(coeffs(fY, basis(RG)), basis(RG), basis(fRG))

            @test coeffs(X * Y, basis(fRG)) == coeffs(fX * fY)
            @test coeffs(X * X, basis(fRG)) ==
                  coeffs(fX^2) ==
                  coeffs(X^2, basis(fRG))

            @test coeffs(Y * Y, basis(fRG)) ==
                  coeffs(fY^2) ==
                  coeffs(Y^2, basis(fRG))

            MA.operate_to!(Z, *, X, Y)
            MA.operate_to!(fZ, *, fX, fY)

            @test coeffs(Z) == coeffs(fZ, basis(RG))
            @test coeffs(fZ) == coeffs(Z, basis(fRG))

            @test coeffs(2 * X * Y) == coeffs(MA.operate_to!(Z, *, 2, Z))
            @test coeffs(2 * fX * fY) == coeffs(MA.operate_to!(fZ, *, 2, fZ))
        end
    end
    @testset "mutable arithmetic" begin
        a = let l = 12, R = 7
            support = [Word(alph, rand(1:length(alph), rand(0:R))) for _ in 1:l]
            vals = rand(-3:3, l)
            c = SA.SparseCoefficients(support, vals)
            MA.operate!(SA.canonical, c)
            AlgebraElement(c, RG)
        end
        b = let l = 7, R = 3
            support = [Word(alph, rand(1:length(alph), rand(0:R))) for _ in 1:l]
            vals = rand(-3:3, l)
            c = SA.SparseCoefficients(support, vals)
            MA.operate!(SA.canonical, c)
            AlgebraElement(c, RG)
        end

        let d = deepcopy(a)
            MA.operate!(zero, d)
            MA.operate_to!(d, -, a)

            d = deepcopy(a)
            @test !iszero(d)
            @test @allocated(MA.operate!(zero, d)) == 0
            @test iszero(d)

            minus_allocated_test(a, d)
            @test d == -a
        end

        let d = zero(a)
            MA.operate_to!(d, +, a, b)
            @test d == a + b
            MA.operate_to!(d, +, d, b)
            @test d == a + 2b
            MA.operate_to!(d, +, b, d)
            @test d == a + 3b
            MA.operate_to!(d, +, a, b)
            @test d == a + b
        end

        let d = deepcopy(a)
            MA.operate_to!(d, *, 2, a)
            @test d == 2a
            MA.operate_to!(d, *, 2, d)
            @test d == 4a
            MA.operate_to!(d, *, a, b)
            @test d == a * b
            @test_throws ArgumentError MA.operate_to!(d, *, d, b)

            d = deepcopy(a)
            MA.operate_to!(d, *, 2, a) # preallocates memory in coefficients
            prod_2_allocated_test(a, d)
            @test d == 2a

            prod_2_allocated_test(d, d)
            @test d == 4a

            MA.operate_to!(d, *, a, b)
            @test d == a * b
            MA.operate!(SA.UnsafeAddMul(*), d, a, b)
            @test d == 2 * a * b

            MA.operate_to!(d, *, a, b)
            @test d == a * b
            d = a + b
            MA.operate!(SA.UnsafeAddMul(*), d, a, b, 3)
            @test d == a + b + 3 * a * b
        end
    end
end

# This file is a part of StarAlgebras.jl. License is MIT: https://github.com/JuliaAlgebra/StarAlgebras.jl/blob/main/LICENSE
# Copyright (c) 2021-2025: Marek Kaluba, Benoît Legat

using Test
using PermutationGroups
import Random
import StarAlgebras as SA
@testset "POC: group algebra" begin
    G = PermGroup(perm"(1,2,3,4,5,6)", perm"(1,2)")
    g = Permutation(perm"(1,4,3,6)(2,5)", G)
    h = Permutation(perm"(2,4,5,1)", G)

    db = SA.DiracBasis(G)
    mstr = SA.DiracMStructure(db, *)
    @test mstr(g, h) == SA.SparseCoefficients((g * h,), (1,))

    @test db[g] == g
    @test db[db[g]] == g

    xcfs = SA.SparseCoefficients([one(G), g], [1, -1])
    ycfs = SA.SparseCoefficients([one(G), inv(g)], [1, -1])
    xycfs = SA.SparseCoefficients([one(G), g, inv(g)], [2, -1, -1])

    zcfs = SA.SparseCoefficients([one(G), h], [1, -1])
    xzcfs = SA.SparseCoefficients([one(G), g, h, g * h], [1, -1, -1, 1])

    RG = SA.StarAlgebra(G, mstr)

    x = SA.AlgebraElement(xcfs, RG)
    y = SA.AlgebraElement(ycfs, RG)
    xy = SA.AlgebraElement(xycfs, RG)
    @test x != y
    @test x' == y
    @test x * y == xy

    z = SA.AlgebraElement(zcfs, RG)
    xz = SA.AlgebraElement(xzcfs, RG)
    @test x * z == xz

    @test isone(one(RG))
    @test x * one(RG) == x
    @test one(RG) * x == x
    @test eltype(one(Float64, RG)) == Float64
    @test isone(one(x))
    @test coeffs(one(x)) == coeffs(one(RG))

    @testset "Augmented basis" begin
        ad = AugmentedBasis(db)
        @test SA.mstructure(ad) == AugmentedMStructure(ad)
        @test ad[Augmented(h)] isa Augmented
        @test sprint(show, ad[Augmented(h)]) == "(-1·()+1·(1,2,4,5))"

        @test !(h in ad)
        @test Augmented(h) in ad

        IG = SA.StarAlgebra(G, ad)

        axcfs = SA.coeffs(x, basis(IG))
        aycfs = SA.coeffs(y, basis(IG))
        azcfs = SA.coeffs(z, basis(IG))
        ax = SA.AlgebraElement(axcfs, IG)
        ay = SA.AlgebraElement(aycfs, IG)
        az = SA.AlgebraElement(azcfs, IG)

        @test coeffs(ax * ay) == SA.coeffs(x * y, basis(IG))
        @test coeffs(ax * az) == SA.coeffs(x * z, basis(IG))
        @test aug(ax) == 0
        @test star(ax) * star(ay) == star(ay) * star(ax)

        @test length(ad) == length(db) - 1
        @test Set(ad) == Set(Augmented(g) for g in db if !isone(g))
    end

    @testset "Random elements (seed=$seed)" for seed in 0:20
        Random.seed!(seed)
        rcfs = SA.SparseCoefficients(rand(G, 10), rand(-2:2, 10))
        r = SA.AlgebraElement(rcfs, RG)
        scfs = SA.SparseCoefficients(rand(G, 10), rand(-2:2, 10))
        s = SA.AlgebraElement(scfs, RG)

        @test aug(r * s) == aug(r) * aug(s)
    end
    @testset "Fixed Basis" begin
        m = PermutationGroups.order(UInt16, G)
        fb = SA.FixedBasis{eltype(G),typeof(m)}(collect(G))

        @test fb[fb[g]] == g

        fRG = SA.StarAlgebra(G, SA.MTable(fb, (m, m)))

        @testset "seed=$seed" for seed in 0:20
            Random.seed!(seed)
            rcfs = SA.SparseCoefficients(rand(G, 10), rand(-2:2, 10))
            r = SA.algebra_element(rcfs, RG)
            scfs = SA.SparseCoefficients(rand(G, 10), rand(-2:2, 10))
            s = SA.algebra_element(scfs, RG)

            @test coeffs(r, basis(fRG)) isa SparseVector

            fr = SA.AlgebraElement(coeffs(r, basis(fRG)), fRG)
            fs = SA.AlgebraElement(coeffs(s, basis(fRG)), fRG)

            @test aug(fr) == aug(r)
            @test aug(fs) == aug(s)
            @test aug(fr * fs) == aug(fr) * aug(fs)

            @test coeffs(r * s, basis(fRG)) isa AbstractVector
            @test fr * fs == SA.AlgebraElement(coeffs(r * s, basis(fRG)), fRG)
        end

        a, b = let mt = SA.mstructure(fRG).table
            count(i -> isassigned(mt, i), eachindex(mt)), length(mt)
        end
        @test a ≤ b

        @test Random.seed!(0) isa Any
        rcfs = SA.SparseCoefficients(rand(G, 10), rand(-2:2, 10))
        r = SA.AlgebraElement(rcfs, RG)
        fr = SA.AlgebraElement(coeffs(r, basis(fRG)), fRG)

        @test isone(one(fRG))
        @test fr * one(fRG) == fr
        @test one(fRG) * fr == fr
        @test eltype(one(Float64, fRG)) == Float64
        @test isone(one(fr))
        @test coeffs(one(fr)) == coeffs(one(fRG))
    end

    @testset "SubBasis" begin
        # If we're unlucky, `a^3` might belong to the basis.
        # We fix the seed to be sure we are never in that case.
        Random.seed!(0)
        S1 = unique!(rand(G, 7))
        S = unique!([S1; [a * b for a in S1 for b in S1]])
        subb = SA.sub_basis(db, S)
        a = S1[1]
        @test subb[a] == 1
        @test a in subb
        @test isnothing(get(subb, a^3, nothing))
        @test_throws KeyError(a^3) subb[a^3]
        @test !(a^3 in subb)
        @test collect(subb) == S
        smstr = SA.DiracMStructure(subb, *)
        @test only(smstr(1, 2).basis_elements) == subb[subb[1]*subb[2]]
        @test only(smstr(1, 2, eltype(subb)).basis_elements) ==
              subb[1] * subb[2]

        sbRG = SA.StarAlgebra(G, smstr)

        x = let z = zeros(Int, length(SA.basis(sbRG)))
            z[1:length(S1)] .= rand(-1:1, length(S1))
            SA.AlgebraElement(z, sbRG)
        end

        y = let z = zeros(Int, length(SA.basis(sbRG)))
            z[1:length(S1)] .= rand(-1:1, length(S1))
            SA.AlgebraElement(z, sbRG)
        end

        dx = SA.AlgebraElement(SA.coeffs(x, SA.basis(RG)), RG)
        dy = SA.AlgebraElement(SA.coeffs(y, SA.basis(RG)), RG)

        @test dx + dy == SA.AlgebraElement(SA.coeffs(x + y, SA.basis(RG)), RG)

        @test dx * dy == SA.AlgebraElement(SA.coeffs(x * y, SA.basis(RG)), RG)

        if !(one(G) in subb)
            @test_throws ArgumentError one(sbRG)
        end

        S2 = unique([S; one(G)])
        subb2 = SA.sub_basis(db, S2)
        let sRG = SA.StarAlgebra(G, subb2)
            x = let z = spzeros(Int, length(SA.basis(sRG)))
                z[rand(1:length(S2), 10)] += rand(-1:1, 10)
                SA.AlgebraElement(z, sRG)
            end
            @test isone(one(sRG))
            @test x * one(sRG) == x
            @test one(sRG) * x == x
            @test eltype(one(Float64, sRG)) == Float64
            @test isone(one(x))
            @test coeffs(one(x)) == coeffs(one(sRG))
        end
    end
    @testset "Algebra Elements Basis (seed = $seed)" for seed in 0:200
        Random.seed!(seed)
        S1 = unique!(collect(Iterators.take(G, 10)))
        S = unique!([a * b for a in S1 for b in S1])

        elts = [RG(g) - RG(1) for g in S]
        elts[begin] = RG(S[2]) + RG(1)
        ab = SA.FixedBasis(elts)
        # basis looks like this: [s₁ + e, s₁ - e, s₂ - e, s₃ - e, …]
        # in particular it doesn't contain 1!

        @test ab[ab[elts[2]]] == elts[2]

        rcfs = SA.SparseCoefficients(rand(elts[1:length(S1)], 5), rand(-2:2, 5))
        scfs = SA.SparseCoefficients(rand(elts[1:length(S1)], 5), rand(-2:2, 5))

        @test coeffs(rcfs, SA.DiracBasis(elts), ab) isa SparseVector

        aRG = SA.StarAlgebra(RG, SA.MTable(ab, (length(S1), length(S1))))

        ar = SA.AlgebraElement(
            coeffs(rcfs, SA.DiracBasis(elts), basis(aRG)),
            aRG,
        )
        as = SA.AlgebraElement(
            coeffs(scfs, SA.DiracBasis(elts), basis(aRG)),
            aRG,
        )

        @test aug(ar) == 2*ar(first(ab)) # one(RG)
        @test aug(as) == 2as(first(ab)) # one(RG)
        @test aug(ar + as) == aug(ar) + aug(as)

        @test coeffs(ar + as, basis(aRG)) isa AbstractVector

        @test_throws ArgumentError one(aRG)
        @test_throws ArgumentError isone(ar)
    end
end

# This file is a part of StarAlgebras.jl. License is MIT: https://github.com/JuliaAlgebra/StarAlgebras.jl/blob/main/LICENSE
# Copyright (c) 2021-2025: Marek Kaluba, Benoît Legat

# Example implementation of Univariate polynomials
# See MultivariatePolynomials.jl for general implementation
struct UnivariateIterator end
Base.eltype(::Type{UnivariateIterator}) = Int
Base.IteratorSize(::Type{UnivariateIterator}) = Base.IsInfinite()

function Base.iterate(::UnivariateIterator)
    z = 0
    return z, z
end

function Base.iterate(::UnivariateIterator, z)
    z += 1
    return z, z
end

struct UniMono
    first_variable::Bool
    exponent::Int
end

Base.one(m::UniMono) = UniMono(m.first_variable, 0)
function Base.:*(a::UniMono, b::UniMono)
    @assert a.first_variable == b.first_variable
    UniMono(a.first_variable, a.exponent + b.exponent)
end

unimono(first, exp) = UniMono(first, exp)
exponent(mono::UniMono) = mono.exponent

SA.comparable(::UnivariateIterator) = isless

function univariate_algebra(first_variable::Bool)
    exps = UnivariateIterator()
    basis = SA.MappedBasis(exps, Base.Fix1(unimono, first_variable), exponent)
    mstr = SA.DiracMStructure(basis, *)
    object = UniMono(first_variable, 0)
    return SA.StarAlgebra(object, mstr)
end

function bivariate_lift(first, deg)
    return first ? (deg, 0) : (0, deg)
end

UniType = typeof(SA.MappedBasis(UnivariateIterator(), Base.Fix1(unimono, true), exponent))
function SA.promote_bases_with_maps(a::UniType, b::UniType)
    if a.map.x == b.map.x
        return (a, nothing), (b, nothing)
    end
    bi_alg = bivariate_algebra()
    bi_bas = SA.basis(bi_alg)
    _a = (bi_bas, Base.Fix1(bivariate_lift, a.map.x))
    _b = (bi_bas, Base.Fix1(bivariate_lift, b.map.x))
    return _a, _b
end

function SA.promote_object(m::UniMono, mstr, map::Base.Fix1)
    return Monomial(map(m.exponent))
end

# This file is a part of StarAlgebras.jl. License is MIT: https://github.com/JuliaAlgebra/StarAlgebras.jl/blob/main/LICENSE
# Copyright (c) 2021-2025: Marek Kaluba, Benoît Legat

"""
    struct DiracBasis{T,S} <: ImplicitBasis{T,T}
        object::S
    end

Given any iterable `object` over elements of type `T`, the basis
corresponds to the list of elements of `object`.
The `object` (its type `S`, respectively) should implement the methods:
```julia
Base.IteratorSize(::Type{S})
Base.eltype(::S) # Should return `T`
Base.iterate(::S)
Base.iterate(::S, state)
Base.in(::T, ::S)
```
Optionally, it may implement the following,
```julia
Base.isempty(::S)
Base.length(::S)
```
"""
struct DiracBasis{T,S} <: ImplicitBasis{T,T}
    object::S

    function DiracBasis(itr)
        @assert !isempty(itr)
        return new{eltype(itr),typeof(itr)}(itr)
    end
end

object(db::DiracBasis) = db.object

function Base.IteratorSize(::Type{<:DiracBasis{T,S}}) where {T,S}
    return Base.IteratorSize(S)
end

function Base.size(db::DiracBasis)
    # Some object such as `PermGroup` do not define `size`
    return (length(db),)
end

function Base.length(db::DiracBasis)
    @assert Base.haslength(object(db))
    return length(object(db))
end

Base.iterate(db::DiracBasis) = iterate(object(db))
Base.iterate(db::DiracBasis, st) = iterate(object(db), st)

Base.in(g, db::DiracBasis) = g in object(db)
Base.haskey(db::DiracBasis, g) = in(g, db)

Base.firstindex(db::DiracBasis) = Base.first(object(db))
function Base.getindex(db::DiracBasis{T}, x::T) where {T}
    @assert x in object(db)
    return x
end

"""
    mutable struct MappedBasis{T,I,S,F,U} <: ImplicitBasis{T,I}
        object::S
        map::F
        inverse_map::U
    end

Given any iterable `object` over elements of type `I`, the basis
corresponds to the list of elements `map(i::I)` where `i` 
belongs to `object`. The function `inverse_map` should
be the inverse of `map`. That is, `inverse_map(map(i))` should be `i`
for all `i in object`.
The `object` (its type `S`, respectively) should implement the methods:
```julia
Base.IteratorSize(::Type{S})
Base.eltype(::S) # Should return `I`
Base.iterate(::S)
Base.iterate(::S, state)
Base.in(::I, ::S)
```
Optionally, it may implement the following,
```julia
Base.isempty(::S)
Base.length(::S)
```
"""
mutable struct MappedBasis{T,I,S,F,U} <: ImplicitBasis{T,I}
    object::S
    map::F
    inverse_map::U

    function MappedBasis{T}(itr, map, inverse_map) where {T}
        @assert !isempty(itr)
        I = eltype(itr)
        @assert T != I || (map == inverse_map == identity)
        return new{T,I,typeof(itr),typeof(map),typeof(inverse_map)}(
            itr,
            map,
            inverse_map,
        )
    end
end

function MappedBasis(itr, map, inverse_map)
    return MappedBasis{typeof(map(first(itr)))}(itr, map, inverse_map)
end

function Base.:(==)(a::MappedBasis, b::MappedBasis)
    return object(a) == object(b) &&
           a.map == b.map &&
           a.inverse_map == b.inverse_map
end

object(db::MappedBasis) = db.object

function Base.IteratorSize(::Type{<:MappedBasis{T,I,S}}) where {T,I,S}
    return Base.IteratorSize(S)
end

function _iterate(b::MappedBasis, elem_state)
    if isnothing(elem_state)
        return
    end
    elem, state = elem_state
    return b.map(elem), state
end
Base.iterate(b::MappedBasis) = _iterate(b, iterate(object(b)))
Base.iterate(b::MappedBasis, st) = _iterate(b, iterate(object(b), st))

function Base.size(b::MappedBasis)
    @assert Base.haslength(object(b))
    return size(object(b))
end

function Base.length(b::MappedBasis)
    @assert Base.haslength(object(b))
    return length(object(b))
end

Base.in(g::T, b::MappedBasis{T}) where {T} = haskey(b, b.inverse_map(g))
Base.haskey(b::MappedBasis{T,I}, k::I) where {T,I} = k in object(b)

function Base.getindex(b::MappedBasis{T}, x::T) where {T}
    return b.inverse_map(x)
end

function Base.getindex(b::MappedBasis{T,I}, x::I) where {T,I}
    return b.map(x)
end

function promote_bases_with_maps(a::ImplicitBasis, b::ImplicitBasis)
    if a == b
        return (a, nothing), (b, nothing)
    end
    return error("Bases $a and $b are different and do not support promotion.")
end

# This file is a part of StarAlgebras.jl. License is MIT: https://github.com/JuliaAlgebra/StarAlgebras.jl/blob/main/LICENSE
# Copyright (c) 2021-2025: Marek Kaluba, Benoît Legat

mutable struct FixedBasis{T,I,V<:AbstractVector{T}} <: ExplicitBasis{T,I}
    elts::V
    relts::Dict{T,I}
    starof::Vector{I}
end

"""
    FixedBasis(elts::AbstractVector)

Represents a linear basis which is fixed of length (given by `elts`).
The elements of `elts` are assumed to be _linearly independent_ and (as a set) invariant under `star`.
Due to its finiteness, `b::FixedBasis` can be indexed like a vector (by positive integers) and therefore elements expressed in `b` can be represented by simple (sparse) Vectors.

## Examples

```julia
julia> import StarAlgebras as SA;

julia> SA.star(s::String) = reverse(s) # identity is also fine

julia> b = SA.FixedBasis(["", "a", "b", "aa", "ab", "ba", "bb"]);

julia> b["a"]
1

julia> b["ab"]
4

julia> b[4]
"ab"

julia> b["abc"]
ERROR: KeyError: key "abc" not found
[...]

julia> A = SA.StarAlgebra(String, SA.DiracMStructure(b, *))
*-algebra of String

julia> c = A("a") + A("b")
1·"a" + 1·"b"

julia> c*A("a")
1·"aa" + 1·"ba"

julia> A("a")*c
1·"aa" + 1·"ab"

julia> c*c
1·"aa" + 1·"ab" + 1·"ba" + 1·"bb"

julia> SA.coeffs(c*c)
7-element SparseArrays.SparseVector{Int64, Int64} with 4 stored entries:
  [4]  =  1
  [5]  =  1
  [6]  =  1
  [7]  =  1
```
"""
function FixedBasis(elts::AbstractVector{T}) where {T}
    return FixedBasis{T,keytype(elts)}(elts)
end

function FixedBasis{T,I}(elts::AbstractVector{T}) where {T,I}
    relts = Dict(b => I(idx) for (idx, b) in pairs(elts))
    starof = [relts[star(x)] for x in elts]
    return FixedBasis{T,I,typeof(elts)}(elts, relts, starof)
end

function FixedBasis{T,I}(basis::AbstractBasis{T}; n::Integer) where {T,I}
    return FixedBasis{T,I}(collect(Iterators.take(basis, n)))
end

function FixedBasis(basis::AbstractBasis{T}; n::Integer) where {T}
    return FixedBasis{T,typeof(n)}(basis; n)
end

Base.in(x, b::FixedBasis) = haskey(b.relts, x)
Base.firstindex(b::FixedBasis) = firstindex(b.elts)
Base.lastindex(b::FixedBasis) = lastindex(b.elts)
Base.getindex(b::FixedBasis{T}, x::T) where {T} = b.relts[x]
Base.getindex(b::FixedBasis, i::Integer) = b.elts[i]

Base.length(b::FixedBasis) = length(b.elts)
Base.iterate(b::FixedBasis) = iterate(b.elts)
Base.iterate(b::FixedBasis, state) = iterate(b.elts, state)
Base.IndexStyle(::Type{<:FixedBasis{T,I,V}}) where {T,I,V} = Base.IndexStyle(V)

function promote_bases_with_maps(a::FixedBasis, b::FixedBasis)
    @assert a == b # Promotion not supported, they need to be equal
    return (a, nothing), (b, nothing)
end

"""
    struct SubBasis{T,I,K,B<:ImplicitBasis{T,K},V<:AbstractVector{K}} <:
        ExplicitBasis{T,I}
        parent_basis::B
        keys::V
        is_sorted::Bool
    end

Represents a sub-basis of a given basis, where `keys` is a vector of keys
representing the sub-basis elements, `parent_basis` is the parent basis from
which the sub-basis is derived, and `is_sorted` indicates whether the keys are
sorted.
"""
struct SubBasis{T,I,K,B<:ImplicitBasis{T,K},V<:AbstractVector{K}} <:
       ExplicitBasis{T,I}
    parent_basis::B
    keys::V
    is_sorted::Bool
    function SubBasis(
        parent_basis::ImplicitBasis{T,K},
        keys::AbstractVector{K},
    ) where {T,K}
        return new{T,keytype(keys),K,typeof(parent_basis),typeof(keys)}(
            parent_basis,
            keys,
            issorted(keys, lt = comparable(parent_basis)),
        )
    end
end

# If `basis.is_sorted` is `true` and `indices` is not sorted,
# maybe we should sort it automatically ?
# Or maybe it's best to just error so that the user has to sort it explicitly
function _check_sorted(indices::AbstractVector)
    if !issorted(indices)
        throw(
            ArgumentError(
                "`sub_basis` expects indices to be sorted but the given indices `$indices` are not sorted",
            ),
        )
    end
end

# No need to check if it's sorted in this case
_check_sorted(::AbstractVector{Bool}) = nothing

"""
    sub_basis(basis::SubBasis, indices::Vector)

Return a `SubBasis` of the same `parent` but the subset of keys
`basis.keys[indices]`.
"""
function sub_basis(basis::SubBasis, indices::AbstractVector)
    _check_sorted(indices)
    return SubBasis(parent(basis), basis.keys[indices])
end

"""
    sub_basis(basis::ImplicitBasis, keys::AbstractVector)

Return a `SubBasis` of `basis` but the subset of keys `keys`.

## Note

Even though the constructor `SubBasis(basis, keys)` allows `basis`
to be a `ExplicitBasis`, this function restricts it to be
an `ImplicitBasis` in order to provide an interface that would
help catch common mistakes.
"""
function sub_basis(basis::ImplicitBasis, keys::AbstractVector)
    return SubBasis(basis, keys)
end

Base.parent(sub::SubBasis) = sub.parent_basis

function Base.:(==)(a::SubBasis, b::SubBasis)
    return a.parent_basis == b.parent_basis && a.keys == b.keys
end

Base.length(b::SubBasis) = length(b.keys)
function _iterate(b::SubBasis, elem_state)
    if isnothing(elem_state)
        return
    end
    elem, state = elem_state
    return parent(b)[elem], state
end
Base.iterate(b::SubBasis) = _iterate(b, iterate(b.keys))
Base.iterate(b::SubBasis, st) = _iterate(b, iterate(b.keys, st))

"""
    key_index(b::SubBasis, key, default = nothing)

Given a key `key` of the basis `parent(b)`, if the key is in `SubBasis` `b` then
it returns the index of the key, otherwise, it returns `default`.
This is a shortcut for `get(b, parent(b)[key], default)`.
"""
function key_index(b::SubBasis{T,I}, key, default = nothing) where {T,I}
    if b.is_sorted
        i = searchsortedfirst(b.keys, key, lt = comparable(parent(b)))
        if i in eachindex(b.keys) && b.keys[i] == key
            return convert(I, i)
        end
    else
        i = findfirst(isequal(key), b.keys)
        if !isnothing(i)
            return convert(I, i)
        end
    end
    return default
end

function Base.get(b::SubBasis{T}, x::T, default) where {T}
    return key_index(b, b.parent_basis[x], default)
end

Base.in(x::T, b::SubBasis{T}) where {T} = !isnothing(get(b, x, nothing))
Base.haskey(b::SubBasis, i::Integer) = i in eachindex(b.keys)

Base.firstindex(b::SubBasis) = firstindex(b.keys)
Base.lastindex(b::SubBasis) = lastindex(b.keys)
Base.getindex(b::SubBasis, i::Integer) = parent(b)[b.keys[i]]
function Base.getindex(b::SubBasis{T,I}, x::T) where {T,I}
    i = get(b, x, nothing)
    if isnothing(i)
        throw(KeyError(x))
    end
    return i::I
end

function promote_with_map(a::SubBasis, basis, m)
    keys_a = map(m, a.keys)
    # The key of basis `a` is a `Integer` so no key mapper needed
    return SubBasis(basis, keys_a), identity
end

function promote_bases_with_maps(a::SubBasis, b::SubBasis)
    _a, _b = promote_bases_with_maps(parent(a), parent(b))
    return maybe_promote(a, _a...), maybe_promote(b, _b...)
end

function promote_bases_with_maps(a::SubBasis, b::ImplicitBasis)
    _a, _b = promote_bases_with_maps(parent(a), b)
    return maybe_promote(a, _a...), _b
end

# This file is a part of StarAlgebras.jl. License is MIT: https://github.com/JuliaAlgebra/StarAlgebras.jl/blob/main/LICENSE
# Copyright (c) 2021-2025: Marek Kaluba, Benoît Legat

struct CustomLaTeXPrint
    s::String
end

Base.:-(s::CustomLaTeXPrint) = s
Base.iszero(::CustomLaTeXPrint) = false
function Base.show(io::IO, ::MIME"text/latex", s::CustomLaTeXPrint)
    return print(io, s.s)
end

@testset "DiracBasis" begin
    db = SA.DiracBasis([2π, -π])
    @test 2π in db
    @test haskey(db, 2π)
    @test !(3π in db)
    @test !haskey(db, 3π)
    @test collect(db) == [2π, -π]
end

@testset "Algebra and Elements" begin
    alph = [:a, :b, :c]
    A★ = FreeWords(alph)
    # If the map does not change the type then it should be `Base.identity`
    @test_throws AssertionError SA.MappedBasis(
        A★,
        i -> i * one(A★),
        i -> i * inv(one(A★)),
    )
    @test_throws AssertionError SA.MappedBasis(A★, i -> i * one(A★), identity)
    @test_throws AssertionError SA.MappedBasis(
        A★,
        identity,
        i -> i * inv(one(A★)),
    )
    B = SA.DiracBasis(A★)
    RG = StarAlgebra(A★, B)
    @test typeof(@inferred basis(RG)) == MA.promote_operation(basis, typeof(RG))

    @test typeof(zero(RG)) == typeof(RG(0))
    @test typeof(one(RG)) == typeof(RG(1))

    @test one(RG) == RG(1)
    @test RG(1) == one(RG(0))

    @test zero(RG) == RG(0)
    @test RG(0) == zero(RG(1))

    x = let A = alph, n = 7
        elts = [Word(A, rand(1:length(A), rand(0:7))) for _ in 1:n]
        vals = rand(-5:5, n)
        coeffs = SA.SparseCoefficients(elts, vals)
        MA.operate!(SA.canonical, coeffs)
    end

    err = ArgumentError(
        "The key type `Int64` of the coefficients does not match the key type `Word{Symbol}` of the algebra `*-algebra of FreeWords{Symbol}([:a, :b, :c])`",
    )
    bad_coeffs = SA.SparseCoefficients([1], [2])
    @test_throws err AlgebraElement(bad_coeffs, RG)

    @test AlgebraElement(x, RG) isa AlgebraElement

    X = AlgebraElement(x, RG)
    @test typeof(@inferred coeffs(X)) == MA.promote_operation(coeffs, typeof(X))
    @test typeof(@inferred basis(X)) == MA.promote_operation(basis, typeof(X))

    @test AlgebraElement{Float64}(X) isa AlgebraElement
    Y = AlgebraElement{Float64}(X)
    @test parent(X) === parent(Y)
    @test X == Y

    p = Word(alph, [2, 3])
    a = RG(p)
    @test coeffs(a)[B[p]] == 1
    @test coeffs(a) isa SA.SparseCoefficients
    @test length(collect(SA.nonzero_pairs(coeffs(a)))) == 1
    @test a(p) == 1

    let b = collect(Iterators.take(B, 121))
        @test all(coeffs(a)[x] == 0 for x in b if x ≠ p)
        @test all(a(g) == 0 for g in b if g != p)
    end

    @test sprint(show, zero(RG)) == "0·(id)"
    @test sprint(show, one(RG)) == "1·(id)"
    @test isone(one(a))
    @test !isone(a)
    @test iszero(zero(a))
    @test sprint(show, a) == "1·b·c"
    @test sprint(show, -a) == "-1·b·c"

    @test hash(a) == hash(one(RG) + RG(p) - one(RG))

    @test SA.supp(a) == [p]
    @test collect(SA.nonzero_pairs(coeffs(a))) == [(p => 1)]

    s = one(first(B))
    @test a(s) == 0

    a[s] = 2

    @test coeffs(a)[s] == 2
    @test a(s) == 2

    # dense_a = AlgebraElement(Vector(coeffs(a)), RG)
    # @test a == dense_a
    # @test hash(a) == hash(dense_a)

    # @test SA.supp_ind(a) == [b[s], b[p]] == SA.supp_ind(dense_a)
    # @test SA.supp(a) == [s, p] == SA.supp(dense_a)

    aa = a - RG(p)
    # dense_aa = dense_a - RG(p)
    # @test SA.supp_ind(aa) == [b[s]] == SA.supp_ind(dense_aa)
    @test SA.supp(aa) == [s]

    @test sprint(show, a) == "2·(id) + 1·b·c"
    @test sprint(show, -a) == "-2·(id) - 1·b·c"
    Z = AlgebraElement{Float64}(a)
    @test Z == a
    @test sprint(show, Z) == "2.0·(id) + 1.0·b·c"
    @test sprint(show, 2one(RG) - RG(p)) == "2·(id) - 1·b·c"
    @test sprint(show, (2 + im) * one(RG) - (3im) * RG(p)) ==
          "(2 + 1im)·(id) + (0 - 3im)·b·c"

    @test sprint(print, (2 + im) * one(RG) - (3im) * RG(p)) ==
          "(2 + 1im)·(id) + (0 - 3im)·b·c"
    @test sprint(show, 1e-9 * one(RG)) == "1.0e-9·(id)"
    @test sprint((io, x) -> show(io, "text/latex", x), 1e-9 * one(RG)) ==
          "\$\$ 1.0 \\cdot 10^{-9} \\cdot (id) \$\$"

    @test LinearAlgebra.norm(a, 1) == 3

    @test copy(a) == a
    @test copy(a) !== a
    @test coeffs(copy(a)) !== coeffs(a)
    @test parent(copy(a)) === parent(a)

    @test deepcopy(a) == a
    @test deepcopy(a) !== a
    @test coeffs(deepcopy(a)) !== coeffs(a)
    @test parent(deepcopy(a)) === parent(a)

    latex = CustomLaTeXPrint(" \$\$ \\[\\(α_β∀ \\) \\]\t  \$\$")
    a = SA.AlgebraElement(SA.SparseCoefficients([p], [latex]), RG)
    # Tests that `getindex` works even if `zero(typeof(latex))` is not defined
    @test SA.coeffs(a)[p] == latex
    @test sprint((io, x) -> show(io, "text/latex", x), a) ==
          "\$\$ (α_β∀) \\cdot b·c \$\$"
    # Test that the check for `\\)` handles unicode well
    latex = CustomLaTeXPrint("\\(β∀")
    @test sprint(
        (io, x) -> show(io, "text/latex", x),
        SA.AlgebraElement(SA.SparseCoefficients([p], [latex]), RG),
    ) == "\$\$ (\\(β∀) \\cdot b·c \$\$"
end

# This file is a part of StarAlgebras.jl. License is MIT: https://github.com/JuliaAlgebra/StarAlgebras.jl/blob/main/LICENSE
# Copyright (c) 2021-2025: Marek Kaluba, Benoît Legat

# Example with Graded Lex Ordering
using Test
import StarAlgebras as SA

@testset "Graded Lex" begin
    alg = bivariate_algebra()
    o = one(alg)
    @test isone(o)
    @test SA.coeffs(o).isless == grlex
    a = SA.AlgebraElement(
        SA.SparseCoefficients(
            collect(Iterators.take(SA.object(SA.basis(alg)), 3)),
            [2, -1, 3],
            grlex,
        ),
        alg,
    )
    c = a * a
    @test c.coeffs.values == [4, -4, 12, 1, -6, 9]
    c_keys = [(0, 0), (0, 1), (1, 0), (0, 2), (1, 1), (2, 0)]
    @test c.coeffs.basis_elements == c_keys
    sub = SA.sub_basis(SA.basis(alg), c_keys)
    @test sub.is_sorted
    for (i, key) in enumerate(c_keys)
        el = SA.basis(alg)[key]
        @test SA.key_index(sub, key) == i
        @test sub[el] == i
        @test sub[i] == el
    end
end

@testset "Promotion of univariate to bivariate" begin
    alg_x = univariate_algebra(true)
    o = one(alg_x)
    @test isone(o)
    @test SA.coeffs(o).isless == isless
    a = SA.AlgebraElement(
        SA.SparseCoefficients(
            collect(Iterators.take(SA.object(SA.basis(alg_x)), 2)),
            [1, 5],
            isless,
        ),
        alg_x,
    )

    alg_y = univariate_algebra(false)
    b = SA.AlgebraElement(
        SA.SparseCoefficients(
            collect(Iterators.take(SA.object(SA.basis(alg_y)), 2)),
            [2, -1],
            isless,
        ),
        alg_y,
    )

    bi_alg = bivariate_algebra()
    c = SA.AlgebraElement(
        SA.SparseCoefficients(
            collect(Iterators.take(SA.object(SA.basis(bi_alg)), 3)),
            [3, -1, 5],
            grlex,
        ),
        bi_alg,
    )

    bas_x = SA.basis(alg_x)
    bas_y = SA.basis(alg_y)
    bas_bi = SA.basis(bi_alg)

    err = ErrorException(
        "Bases $bas_x and $bas_bi are different and do not support promotion.",
    )
    @test_throws err SA.promote_bases(bas_x, bas_bi)

    @test c == a + b

    bi_a, _b = SA.promote_bases(a, alg_y)
    @test _b == bi_alg
    @test parent(bi_a) == _b
    bi_b, _b = SA.promote_bases(b, SA.basis(alg_x))
    @test parent(bi_b) == bi_alg
    @test SA.basis(bi_b) == _b
    @test parent(bi_a) == parent(bi_b)

    @test c == bi_a + bi_b

    @testset "SubBasis" begin
        sub_x = SA.SubBasis(bas_x, [1, 3])
        sub_y = SA.SubBasis(bas_y, [2, 3])
        _sub_x, _y = SA.promote_bases(sub_x, bas_y)
        @test parent(_sub_x) == bas_bi
        @test _sub_x.keys == [(1, 0), (3, 0)]
        @test _sub_x.is_sorted
        @test _y == bas_bi
        _sub_x, _sub_y = SA.promote_bases(sub_x, sub_y)
        @test parent(_sub_x) == bas_bi
        @test _sub_x.is_sorted
        @test _sub_x.keys == [(1, 0), (3, 0)]
        @test parent(_sub_y) == bas_bi
        @test _sub_y.is_sorted
        @test _sub_y.keys == [(0, 2), (0, 3)]
    end
end

# This file is a part of StarAlgebras.jl. License is MIT: https://github.com/JuliaAlgebra/StarAlgebras.jl/blob/main/LICENSE
# Copyright (c) 2021-2025: Marek Kaluba, Benoît Legat

function Base.show(io::IO, A::AbstractStarAlgebra)
    ioc = IOContext(io, :limit => true, :compact => true)
    return print(ioc, "*-algebra of ", object(A))
end

__needs_parens(::Any) = false
__needs_parens(a::AlgebraElement) = true

# `print_coefficient` is inspired from MultivariatePolynomials.jl

# `Int`, `Float64` don't support MIME"text/latex".
# We could add a check with `showable` if a `Real` subtype supports it and
# the feature is requested.
print_coefficient(io::IO, ::MIME, coeff::Real) = print(io, coeff)
# Scientific notation does not display well in LaTeX so we rewrite it
function print_coefficient(io::IO, ::MIME"text/latex", coeff::AbstractFloat)
    s = string(coeff)
    if occursin('e', s)
        s = replace(s, 'e' => " \\cdot 10^{") * '}'
    end
    return print(io, s)
end

trim_LaTeX(_, s::AbstractString) = s

function trim_LaTeX(::MIME"text/latex", s::AbstractString)
    i = firstindex(s)
    j = lastindex(s)
    while true
        if i < j && isspace(s[i])
            i = nextind(s, i)
        elseif i < j && isspace(s[j])
            j = prevind(s, j)
        elseif i < j && s[i] == '$' && s[j] == '$'
            i = nextind(s, i)
            j = prevind(s, j)
        elseif i < j && (
            (s[i:nextind(s, i)] == "\\(" && s[prevind(s, j):j] == "\\)") ||
            (s[i:nextind(s, i)] == "\\[" && s[prevind(s, j):j] == "\\]")
        )
            i = nextind(s, i, 2)
            j = prevind(s, j, 2)
        else
            return s[i:j]
        end
    end
end

# JuMP expressions supports LaTeX output so `showable` will return `true`
# for them. It is important for anonymous variables to display properly as well:
# https://github.com/jump-dev/SumOfSquares.jl/issues/256
# Since they add `$$` around it, we need to trim it with `trim_LaTeX`
function print_coefficient(io::IO, mime, coeff)
    print(io, "(")
    print_mime(io, mime, coeff)
    print(io, ")")
    return
end

function print_mime(io::IO, mime, x)
    if showable(mime, x)
        print(io, trim_LaTeX(mime, sprint(show, mime, x)))
    else
        show(io, x)
    end
end

isnegative(x::Real) = x < 0
isnegative(x) = false

_print_dot(io, ::MIME"text/latex") = print(io, " \\cdot ")
_print_dot(io, ::MIME) = print(io, '·')

function _coeff_elt_print(io, mime, c, elt)
    print_coefficient(io, mime, c)
    _print_dot(io, mime)
    __needs_parens(elt) && print(io, '(')
    print_mime(io, mime, elt)
    __needs_parens(elt) && print(io, ')')
    return
end

Base.print(io::IO, a::AlgebraElement) = show(io, MIME"text/print"(), a)
Base.show(io::IO, a::AlgebraElement) = show(io, MIME"text/plain"(), a)

function Base.show(io::IO, mime::MIME"text/latex", a::AlgebraElement)
    print(io, "\$\$ ")
    _show(io, mime, a)
    return print(io, " \$\$")
end

# If the MIME is not specified, IJulia thinks that it supports images, ...
# and then use the result of show and tries to interpret it as an svg, ...
# We need the two methods to avoid ambiguity
function Base.show(io::IO, mime::MIME"text/plain", a::AlgebraElement)
    return _show(io, mime, a)
end
function Base.show(io::IO, mime::MIME"text/print", a::AlgebraElement)
    return _show(io, mime, a)
end

function _show(io::IO, mime, a::AlgebraElement)
    A = parent(a)
    if iszero(a)
        T = value_type(coeffs(a))
        _coeff_elt_print(io, mime, zero(T), first(basis(A)))
    else
        _first = true
        for (idx, value) in nonzero_pairs(coeffs(a))
            c, elt = value, basis(A)[idx]
            if _first
                _coeff_elt_print(io, mime, c, elt)
                _first = false
            else
                neg = isnegative(c)
                print(io, ' ', neg ? '-' : '+', ' ')
                _coeff_elt_print(io, mime, neg ? abs(c) : c, elt)
            end
        end
    end
end

# This file is a part of StarAlgebras.jl. License is MIT: https://github.com/JuliaAlgebra/StarAlgebras.jl/blob/main/LICENSE
# Copyright (c) 2021-2025: Marek Kaluba, Benoît Legat

abstract type AbstractStarAlgebra{O,T} end

function _key_type_check(coeffs, A::AbstractStarAlgebra)
    KC = key_type(coeffs)
    KA = key_type(basis(A))
    if KC != KA
        throw(
            ArgumentError(
                "The key type `$KC` of the coefficients does not match the key type `$KA` of the algebra `$A`",
            ),
        )
    end
end

function _sanity_checks(coeffs, A::AbstractStarAlgebra)
    return _key_type_check(coeffs, A)
end
function _sanity_checks(coeffs::AbstractVector, A::AbstractStarAlgebra)
    @assert Base.haslength(basis(A))
    @assert length(coeffs) == length(basis(A))
end

"""
    struct StarAlgebra{O,T,M<:MultiplicativeStructure{T}} <: AbstractStarAlgebra{O,T}
        object::O
        mstructure::M
    end

Star algebra implementation with an `object` that should implement `one(::O)` and
a [`MultiplicativeStructure`](@ref) `mstructure`.
"""
struct StarAlgebra{O,T,M<:MultiplicativeStructure{T}} <:
       AbstractStarAlgebra{O,T}
    object::O
    mstructure::M
end

function StarAlgebra(object, basis::AbstractBasis)
    return StarAlgebra(object, DiracMStructure(basis, *))
end

mstructure(A::StarAlgebra) = A.mstructure
basis(A::StarAlgebra) = basis(mstructure(A))
function MA.promote_operation(
    ::typeof(basis),
    ::Type{StarAlgebra{O,T,M}},
) where {O,T,M}
    return MA.promote_operation(basis, M)
end
object(A::StarAlgebra) = A.object
Base.isempty(A::StarAlgebra) = isempty(basis(A))
function Base.:(==)(a::StarAlgebra, b::StarAlgebra)
    return a.object == b.object && a.mstructure == b.mstructure
end

"""
    struct AlgebraElement{T,A<:AbstractStarAlgebra,V} <: MA.AbstractMutable
        coeffs::V
        parent::A
    end

Represent an element of the algebra `parent` with coefficients `coeffs`.
The coefficients is a mapping from `keys(coeffs)` to `values(coeffs)`.
The basis element correponding to a key `key` can be obtained via `parent[key]`.

The coefficients are **always** in canonicalized state, meaning the coefficients are
sorted in increasing key order without duplicate keys.
Don't call this constructor with a value of `coeffs` that is in canonical form.
If unsure whether `coeffs` is in canonical form, call [`algebra_element`](@ref) instead of the `AlgebraElement` constructor.

The [`UnsafeAddMul`] and [`UnsafeAdd`] operations may break the canonicalized state of
`AlgebraElement`, hence the `Unsafe` prefix in their name,
the algebra element, say `a`, should be canonicalized with
`MA.operate!(canonical, a)` after using these unsafe operations and
before using other operations which assumes the canonicalized state.
"""
struct AlgebraElement{T,A<:AbstractStarAlgebra,V} <: MA.AbstractMutable
    coeffs::V
    parent::A
end

# TODO we could add an additional argument with SortedUniqState etc... from MultivariatePolynomials
"""
    algebra_element(coeffs, parent::AbstractStarAlgebra)

Same as `AlgebraElement(coeffs, parent)` but also canonicalizes `coeffs`.
"""
function algebra_element(coeffs, parent::AbstractStarAlgebra)
    a = AlgebraElement(coeffs, parent)
    MA.operate!(canonical, a)
    return a
end

Base.parent(a::AlgebraElement) = a.parent
Base.in(x::AlgebraElement, A::AbstractStarAlgebra) = parent(x) == A

mstructure(a::AlgebraElement) = mstructure(parent(a))
function Base.eltype(::Type{A}) where {A<:AlgebraElement}
    return value_type(MA.promote_operation(coeffs, A))
end
Base.eltype(a::AlgebraElement) = eltype(typeof(a))
function MA.promote_operation(
    ::typeof(coeffs),
    ::Type{AlgebraElement{T,A,V}},
) where {T,A,V}
    return V
end
coeffs(a::AlgebraElement) = a.coeffs

function MA.operate!(T::typeof(canonical), a::AlgebraElement)
    return MA.operate!(T, coeffs(a))
end

function coeffs(x::AlgebraElement, b::AbstractBasis)
    return coeffs(coeffs(x), basis(x), b)
end
function adjoint_coeffs(a::AlgebraElement, target::AbstractBasis)
    return adjoint_coeffs(coeffs(a), target, basis(a))
end
function MA.promote_operation(
    ::typeof(basis),
    ::Type{<:AlgebraElement{T,A}},
) where {T,A}
    return MA.promote_operation(basis, A)
end
basis(a::AlgebraElement) = basis(parent(a))

function AlgebraElement(coeffs, A::AbstractStarAlgebra)
    _sanity_checks(coeffs, A)
    return AlgebraElement{value_type(coeffs),typeof(A),typeof(coeffs)}(
        coeffs,
        A,
    )
end

function AlgebraElement(
    coeffs::SparseCoefficients{T},
    A::AbstractStarAlgebra{O,T},
) where {O,T}
    return AlgebraElement{value_type(coeffs),typeof(A),typeof(coeffs)}(
        coeffs,
        A,
    )
end

### constructing elements
function __coerce(A::AbstractStarAlgebra, (x, v)::Pair{K,V}) where {K,V}
    if iszero(v)
        return AlgebraElement(zero_coeffs(V, basis(A)), A)
    elseif x in basis(A)
        cfs = zero_coeffs(V, basis(A))
        cfs[basis(A)[x]] = v
        return AlgebraElement(cfs, A)
        # elseif x in object(A)
        #     sc = SparseCoefficients([x], [v])
        #     return AlgebraElement(
        #         coeffs(sc, DiracBasis(object(A)), basis(A)),
        #         A,
        #     )
    else
        throw(ArgumentError("cannot coerce $x to $A"))
    end
end

Base.zero(A::AbstractStarAlgebra) = zero(Int, A)
function Base.zero(T::Type, A::AbstractStarAlgebra)
    return AlgebraElement(zero_coeffs(T, basis(A)), A)
end
Base.zero(a::AlgebraElement) = (b = similar(a); return MA.operate!(zero, b))
Base.iszero(a::AlgebraElement) = iszero(coeffs(a))

Base.one(A::AbstractStarAlgebra) = one(Int, A)
function Base.one(T::Type, A::AbstractStarAlgebra)
    return __coerce(A, (one(object(A)) => one(T)))
end
Base.one(a::AlgebraElement) = one(eltype(a), parent(a))

function Base.isone(a::AlgebraElement)
    A = parent(a)
    id = one(object(A))
    if id in basis(A)
        for (i, v) in nonzero_pairs(coeffs(a))
            isone(v) || return false
            id == basis(A)[i] || return false
        end
        return true
    else
        throw(
            ArgumentError(
                "basis of $A does not contain $id; `one` and `isone` are unsupported",
            ),
        )
        # return a == one(a)
    end
end

(A::AbstractStarAlgebra{O,T})(elt::T) where {O,T} = __coerce(A, (elt => 1))
(A::AbstractStarAlgebra)(x::Number) = __coerce(A, (one(object(A)) => x))

function similar_type(::Type{AlgebraElement{T,A,V}}, ::Type{C}) where {A,T,V,C}
    return AlgebraElement{C,A,similar_type(V, C)}
end

function Base.similar(X::AlgebraElement, T = eltype(X))
    return AlgebraElement(similar(coeffs(X), T), parent(X))
end

function AlgebraElement{T}(X::AlgebraElement) where {T}
    v = coeffs(X)
    w = similar(v, T)
    MA.operate!(zero, w)
    for (k, v) in nonzero_pairs(v)
        w[k] = v
    end
    return AlgebraElement(w, parent(X))
end

function Base.convert(
    ::Type{AlgebraElement{T,A,V}},
    a::AlgebraElement{T,A,V},
) where {T,A,V}
    return a
end

# Useful for instance if `V` is `SparseCoefficients` with `Tuple`
# and `U` is `SparseCoefficients` with `Vector`
function Base.convert(
    ::Type{AlgebraElement{T,A,U}},
    a::AlgebraElement{T,A,V},
) where {A,T,U,V}
    return AlgebraElement(convert(U, coeffs(a)), parent(a))
end

# This file is a part of StarAlgebras.jl. License is MIT: https://github.com/JuliaAlgebra/StarAlgebras.jl/blob/main/LICENSE
# Copyright (c) 2021-2025: Marek Kaluba, Benoît Legat

# implementations of the free monoid over an alphabet
struct Word{T}
    alphabet::Vector{T}
    letters::Vector{Int}

    function Word(a::AbstractVector{T}, l::AbstractVector{<:Integer}) where {T}
        all(i -> 1 <= i <= length(a), l) ||
            throw(ArgumentError("Invalid word over alphabet $a: $w"))
        return new{T}(a, l)
    end
end
Base.length(w::Word) = length(w.letters)
function Base.show(io::IO, w::Word)
    if isone(w)
        print(io, "(id)")
    else
        join(io, w.alphabet[w.letters], "·")
    end
end

function Base.:(==)(w::Word, v::Word)
    return w.alphabet == v.alphabet && w.letters == v.letters
end
Base.hash(w::Word, h::UInt) = hash(w.alphabet, hash(w.letters, hash(Word, h)))

Base.one(w::Word) = Word(w.alphabet, Int[])
Base.isone(w::Word) = length(w) == 0

function Base.:*(w::Word, z::Word)
    @assert w.alphabet == z.alphabet
    return Word(w.alphabet, [w.letters; z.letters])
end

function StarAlgebras.star(w::Word)
    # star(:a) = :b
    # star(:b) = :a
    # star(:c) = :c

    star_d = Dict(1 => 2, 2 => 1)

    newletters = [get(star_d, l, l) for l in Iterators.reverse(w.letters)]
    return Word(w.alphabet, newletters)
end

Base.isless(w::Word, v::Word) = w.letters < v.letters

struct FreeWords{T}
    alphabet::Vector{T}
end

Base.one(fw::FreeWords) = Word(fw.alphabet, Int[])

Base.eltype(::Type{FreeWords{T}}) where {T} = Word{T}
Base.IteratorSize(::Type{<:FreeWords}) = Base.IsInfinite()
function Base.iterate(aw::FreeWords)
    w = Word(aw.alphabet, Int[])
    stack = [w]
    return w, (stack, 1)
end
# This is needed for fast indexing into DiracBasis:
Base.in(x::Word, fw::FreeWords) = x.alphabet == fw.alphabet

function Base.iterate(aw::FreeWords, state)
    stack, l = state
    if l > length(aw.alphabet)
        popfirst!(stack)
        l = 1
    end
    w = first(stack)
    nw = Word(aw.alphabet, [w.letters; l])
    push!(stack, nw)
    return nw, (stack, l + 1)
end

nwords(M::FreeWords, maxl::Integer) = nwords(M, 0, maxl)
function nwords(M::FreeWords, minl::Integer, maxl::Integer)
    maxl < minl && return zero(maxl)
    k = oftype(maxl, length(M.alphabet))
    return sum(k^i for i in minl:maxl)
end

# This file is a part of StarAlgebras.jl. License is MIT: https://github.com/JuliaAlgebra/StarAlgebras.jl/blob/main/LICENSE
# Copyright (c) 2021-2025: Marek Kaluba, Benoît Legat

struct ProductNotWellDefined <: Exception
    i::Any
    j::Any
    msg::Any
end

function Base.showerror(io::IO, ex::ProductNotWellDefined)
    print(
        io,
        "Product of elements $(ex.i) and $(ex.j) is not defined on the basis",
    )
    print(io, " or the multiplicative structure could not be completed")
    if isdefined(ex, :msg)
        print(io, ": $(ex.msg)")
    end
    return print(io, ".")
end

"""
    MultiplicativeStructure{T,I}
Structure representing multiplication w.r.t its basis.

Implements
* `basis(ms::MultiplicativeStructure{T,I}) → AbstractBasis{T}`
* `(ms::MultiplicativeStructure{T,I})(i::V, j::V, ::Type{U}) where {V<:Union{T,I},U<:Union{T,I}} →
        Union{AbstractCoefficients, AbstractVector}`
   the product of `i` and `j` represented by coefficients in `basis(ms)`
   for which the keys are of type `U<:Union{T,I}`.

The following shortcuts are provided:
* `(ms::MultiplicativeStructure{T})(i::T, j::T)` → `ms(i, j, T)`
* `(ms::MultiplicativeStructure{T,I})(i::I, j::I)` → `ms(i, j, I)`
* `(ms::MultiplicativeStructure)[x]` → `basis(ms)[x]`

When the product is not representable faithfully,
   `ProductNotWellDefined` exception should be thrown.
"""
abstract type MultiplicativeStructure{T,I} end

function (mstr::MultiplicativeStructure{T})(x::T, y::T) where {T}
    return mstr(x, y, T)
end

function (mstr::MultiplicativeStructure{T,I})(x::I, y::I) where {T,I}
    return mstr(x, y, I)
end

function (mstr::MultiplicativeStructure{T,I})(
    x::Integer,
    y::Integer,
) where {T,I<:Integer}
    return mstr(convert(I, x), convert(I, y), I)
end

# To break ambiguity for `DiracBasis` for which `T` and `I` are the same
function (mstr::MultiplicativeStructure{T,T})(x::T, y::T) where {T}
    return mstr(x, y, T)
end

Base.getindex(mstr::MultiplicativeStructure, x) = basis(mstr)[x]

basis(mstr::MultiplicativeStructure) = mstr.basis

struct UnsafeAddMul{M<:Union{typeof(*),MultiplicativeStructure}}
    structure::M
end

"""
    operate_to!(res, ms::MultiplicativeStructure, A, B, α)
Compute `α·A·B` storing the result in `res`. Return `res`.

`res` is assumed to behave like `AbstractCoefficients` and not aliased with any
other arguments.
`A` and `B` are assumed to behave like `AbstractCoefficients`, while `α` will
be treated as a scalar.

Canonicalization of the result happens only once at the end of the operation.
"""
function MA.operate_to!(res, ms::MultiplicativeStructure, A, B, α = true)
    if any(Base.Fix1(===, res), (A, B))
        throw(
            ArgumentError(
                "Aliasing arguments in multiplication is not supported",
            ),
        )
    end
    MA.operate!(zero, res)
    res = MA.operate!(UnsafeAddMul(ms), res, A, B, α)
    MA.operate!(canonical, res)
    return res
end

struct UnsafeAdd end

function MA.operate!(::UnsafeAdd, res, b)
    for (k, v) in nonzero_pairs(b)
        unsafe_push!(res, k, v)
    end
    return res
end

function MA.operate!(::UnsafeAddMul, res, A, α)
    for (k, v) in nonzero_pairs(A)
        unsafe_push!(res, k, v * α)
    end
end

function MA.operate!(op::UnsafeAddMul, res, A, B, α)
    for (kA, vA) in nonzero_pairs(A)
        for (kB, vB) in nonzero_pairs(B)
            MA.operate!(op, res, op.structure(kA, kB), MA.@rewrite(α * vA * vB))
        end
    end
    return res
end

struct DiracMStructure{T,I,B<:AbstractBasis{T,I},Op} <:
       MultiplicativeStructure{T,I}
    basis::B
    op::Op
end

function Base.:(==)(a::DiracMStructure, b::DiracMStructure)
    return a.op == b.op && a.basis == b.basis
end

function MA.promote_operation(
    ::typeof(basis),
    ::Type{<:DiracMStructure{T,I,B}},
) where {T,I,B}
    return B
end

function (mstr::DiracMStructure{T})(x::T, y::T, ::Type{T}) where {T}
    xy = mstr.op(x, y)
    return SparseCoefficients((xy,), (1,))
end

function (mt::DiracMStructure{T,I})(x, y, ::Type{I}) where {T,I}
    return map_keys(Base.Fix1(getindex, mt), mt(x, y, T))
end

function (mstr::DiracMStructure{T,I})(x::I, y::I, ::Type{U}) where {T,I,U}
    return mstr(mstr[x], mstr[y], U)
end

# To break ambiguity for `DiracBasis` for which `T` and `I` are the same
function (mstr::DiracMStructure{T,T})(x::T, y::T, ::Type{T}) where {T}
    xy = mstr.op(x, y)
    return SparseCoefficients((xy,), (1,))
end

function promote_with_map(a::DiracMStructure, b::AbstractBasis, map)
    # We assume `a.op` doesn't need to be mapped
    return DiracMStructure(b, a.op), map
end

function promote_bases_with_maps(a::DiracMStructure, b::DiracMStructure)
    _a, _b = promote_bases_with_maps(basis(a), basis(b))
    return maybe_promote(a, _a...), maybe_promote(b, _b...)
end

function promote_bases_with_maps(a::DiracMStructure, b::AbstractBasis)
    _a, _b = promote_bases_with_maps(basis(a), b)
    return maybe_promote(a, _a...), _b
end

# This file is a part of StarAlgebras.jl. License is MIT: https://github.com/JuliaAlgebra/StarAlgebras.jl/blob/main/LICENSE
# Copyright (c) 2021-2025: Marek Kaluba, Benoît Legat

"""
    QuadraticForm(Q)
    QuadraticForm{star}(Q)
A simple wrapper for representing a quadratic form.

`QuadraticForm(Q)` represents an honest quadratic form, however in the context
of `*`-algebras a more canonical object is a **sesquilinear form** which can be
constructed as `QuadraticForm{star}(Q)`.

Both objects are defined by matrix coefficients with respect to their bases `b`,
i.e. their values at `i`-th and `j`-th basis elements:
    `star.(b)·Q·b = ∑ᵢⱼ Q[i,j]·star(b[i])·b[j]`.

# Necessary methods:
 * `basis(Q)` - a **finite** basis `b` of the quadratic form;
 * `Base.getindex(Q, i::T, j::T)` - the value at `i`-th and `j`-th basis elements
   where `T` is the type of indicies of `basis(Q)`;
 * `Base.eltype(Q)` - the type of `Q[i,j]·star(b[i])·b[j]`.
"""
struct QuadraticForm{T,involution}
    Q::T
    QuadraticForm(Q) = new{typeof(Q),identity}(Q)
    QuadraticForm{star}(Q) = new{typeof(Q),star}(Q)
end

Base.eltype(qf::QuadraticForm) = eltype(qf.Q)
basis(qf::QuadraticForm) = basis(qf.Q)
Base.getindex(qf::QuadraticForm, i::T, j::T) where {T} = qf.Q[i, j]

function MA.operate_to!(res::AlgebraElement, ::typeof(+), Q::QuadraticForm)
    MA.operate!(zero, res)
    MA.operate!(UnsafeAdd(), res, Q)
    MA.operate!(canonical, res)
    return res
end

function MA.operate!(
    ::UnsafeAdd,
    res::AlgebraElement,
    Q::QuadraticForm{T,ε},
) where {T,ε}
    op = UnsafeAddMul(*)
    for (i, b1) in pairs(basis(Q))
        b1★ = ε(b1)
        for (j, b2) in pairs(basis(Q))
            MA.operate!(op, res, b1★, b2, Q[i, j])
        end
    end
end

function MA.operate!(
    op::UnsafeAddMul,
    res::AlgebraElement{C,A},
    b1::T,
    b2::T,
    a,
) where {C,O,T,A<:AbstractStarAlgebra{O,T}}
    mstr = mstructure(res)
    return MA.operate!(op, coeffs(res), mstr(mstr[b1], mstr[b2]), a)
end

"""
    AlgebraElement(qf::QuadraticForm, A::AbstractStarAlgebra)
Construct an algebra element in `A` representing quadratic form `qf`.

!!! warning
    It is assumed that all basis elements of `qf` belong to `A`, or at least
    that `keys` of their coefficients can be found in the basis of `A`.
"""
function AlgebraElement(qf::QuadraticForm, A::AbstractStarAlgebra)
    @assert all(basis(qf)) do b
        return !isa(b, AlgebraElement) || parent(b) == A
    end
    res = zero(eltype(qf), A)
    MA.operate_to!(res, +, qf)
    return res
end

(A::AbstractStarAlgebra)(qf::QuadraticForm) = AlgebraElement(qf, A)

# This file is a part of StarAlgebras.jl. License is MIT: https://github.com/JuliaAlgebra/StarAlgebras.jl/blob/main/LICENSE
# Copyright (c) 2021-2025: Marek Kaluba, Benoît Legat

_coeff_type(::Type{A}) where {A<:AlgebraElement} = eltype(A)
_coeff_type(a::Type) = a
_coeff_type(a) = _coeff_type(typeof(a))

function algebra_promote_operation(op, args::Vararg{Type,N}) where {N}
    T = MA.promote_operation(op, _coeff_type.(args)...)
    if args[2] <: AlgebraElement &&
       MA.promote_operation(coeffs, args[2]) <: DenseArray # what a hack :)
        return similar_type(args[2], T)
    end
    return similar_type(args[1], T)
end

function _preallocate_output(op, args::Vararg{Any,N}) where {N}
    T = MA.promote_operation(op, _coeff_type.(args)...)
    if args[2] isa AlgebraElement && coeffs(args[2]) isa DenseArray # what a hack :)
        return similar(args[2], T)
    end
    return similar(args[1], T)
end

# module structure:

Base.:*(X::AlgebraElement, a::Number) = a * X
Base.:(/)(X::AlgebraElement, a::Number) = inv(a) * X
Base.:(//)(X::AlgebraElement, a::Number) = 1 // a * X

function Base.:-(X::AlgebraElement)
    return MA.operate_to!(_preallocate_output(*, X, -1), -, X)
end
function MA.promote_operation(
    ::typeof(*),
    ::Type{T},
    ::Type{A},
) where {T<:Number,A<:AlgebraElement}
    return algebra_promote_operation(*, A, T)
end
function Base.:*(a::Any, X::AlgebraElement)
    return MA.operate_to!(_preallocate_output(*, X, a), *, a, X)
end
function Base.:div(X::AlgebraElement, a::Number)
    return MA.operate_to!(_preallocate_output(div, X, a), div, X, a)
end
function Base.:*(
    a::T,
    X::AlgebraElement{C,A},
) where {T,C,O,A<:AbstractStarAlgebra{O,T}}
    return MA.operate_to!(similar(X), __lmul, a, X)
end
function Base.:*(
    X::AlgebraElement{C,A},
    a::T,
) where {C,T,O,A<:AbstractStarAlgebra{O,T}}
    return MA.operate_to!(similar(X), __rmul, a, X)
end

for op in [:+, :-, :*]
    @eval begin
        function MA.promote_operation(
            ::typeof($op),
            ::Type{X},
            ::Type{Y},
        ) where {X<:AlgebraElement,Y<:AlgebraElement}
            return algebra_promote_operation($op, X, Y)
        end
        function Base.$op(X::AlgebraElement, Y::AlgebraElement)
            _X, _Y = promote_bases(X, Y)
            return MA.operate_to!(_preallocate_output($op, _X, _Y), $op, _X, _Y)
        end
    end
end

Base.:^(a::AlgebraElement, p::Integer) = Base.power_by_squaring(a, p)

# mutable API

function MA.operate!(::typeof(zero), a::AlgebraElement)
    MA.operate!(zero, coeffs(a))
    return a
end

function MA.operate_to!(
    res::AlgebraElement,
    ::typeof(*),
    a::Any,
    X::AlgebraElement,
)
    @assert parent(res) === parent(X)
    MA.operate_to!(coeffs(res), *, a, coeffs(X))
    return res
end

function MA.operate_to!(
    res::AlgebraElement,
    ::typeof(div),
    X::AlgebraElement,
    a::Number,
)
    @assert parent(res) === parent(X)
    MA.operate_to!(coeffs(res), div, coeffs(X), a)
    return res
end

function MA.operate_to!(
    res::AlgebraElement,
    mul::Union{typeof(__lmul),typeof(__rmul)},
    a,
    X::AlgebraElement,
)
    @assert parent(res) == parent(X)
    MA.operate_to!(coeffs(res), mul, a, coeffs(X))
    return res
end

function MA.operate_to!(res::AlgebraElement, ::typeof(-), X::AlgebraElement)
    @assert parent(res) === parent(X)
    MA.operate_to!(coeffs(res), -, coeffs(X))
    return res
end

function MA.operate_to!(
    res::AlgebraElement,
    ::typeof(+),
    X::AlgebraElement,
    Y::AlgebraElement,
)
    @assert parent(res) == parent(X)
    @assert parent(X) == parent(Y)
    MA.operate_to!(coeffs(res), +, coeffs(X), coeffs(Y))
    return res
end

function MA.operate_to!(
    res::AlgebraElement,
    ::typeof(-),
    X::AlgebraElement,
    Y::AlgebraElement,
)
    @assert parent(res) == parent(X)
    @assert parent(X) == parent(Y)
    MA.operate_to!(coeffs(res), -, coeffs(X), coeffs(Y))
    return res
end

function MA.operate_to!(
    res::AlgebraElement,
    ::typeof(*),
    A::AlgebraElement,
    B::AlgebraElement,
)
    @assert parent(res) == parent(A)
    @assert parent(A) == parent(B)
    mstr = mstructure(res)
    MA.operate_to!(coeffs(res), mstr, coeffs(A), coeffs(B), true)
    return res
end

function MA.operate!(
    ::UnsafeAddMul{typeof(*)},
    res::AlgebraElement,
    A::AlgebraElement,
    B::AlgebraElement,
    α = true,
)
    mstr = mstructure(res)
    op = UnsafeAddMul(mstr)
    MA.operate!(op, coeffs(res), coeffs(A), coeffs(B), α)
    return res
end

function MA.operate!(add::UnsafeAdd, res::AlgebraElement, A::AlgebraElement)
    MA.operate!(add, coeffs(res), coeffs(A))
    return res
end

# TODO just push to internal vectors once canonical `does` not just
# call `dropzeros!` but also reorders
function unsafe_push!(a::SparseArrays.SparseVector, k, v)
    a[k] = MA.add!!(a[k], v)
    return a
end

function unsafe_push!(a::Vector, k, v)
    a[k] = MA.add!!(a[k], v)
    return a
end

# This file is a part of StarAlgebras.jl. License is MIT: https://github.com/JuliaAlgebra/StarAlgebras.jl/blob/main/LICENSE
# Copyright (c) 2021-2025: Marek Kaluba, Benoît Legat

Base.adjoint(a::AlgebraElement) = star(a)
star(x::Any) = x'

function star(X::AlgebraElement)
    res = star(mstructure(X), coeffs(X))
    return AlgebraElement(res, parent(X))
end

star(mstr::MultiplicativeStructure, x) = star(basis(mstr), x)

star(::AbstractBasis, x) = star(x)

function star(b::AbstractBasis, d::SparseCoefficients)
    k = star.(Ref(b), keys(d))
    v = star.(values(d))
    return SparseCoefficients(k, v, d.isless)
end

function star(b::FixedBasis, i::Integer)
    return b.starof[i]
end

function star(b::FixedBasis{T}, el::T) where {T}
    return b[star(b, b[el])]
end

function star(b::FixedBasis, coeffs::SparseVector)
    nzidcs = b.starof[SparseArrays.nonzeroinds(coeffs)]
    nzvals = star.(SparseArrays.nonzeros(coeffs))

    return SparseVector(length(coeffs), nzidcs, nzvals)
end

```@meta
CurrentModule = StarAlgebras
```

# StarAlgebras

Documentation for [StarAlgebras](https://juliaalgebra.github.com/StarAlgebras.jl).

```@index
```

```@autodocs
Modules = [StarAlgebras]
```
